/*******************************************************************************
*
*
* File:        app_tp_transfer.c
* Description  touch I2C/SPI ʼԼͨ
* Version      V0.1
* Date         2021-10-14
* Author       zhanghz
*******************************************************************************/
#include "test_cfg_global.h"
#include "app_tp_transfer.h"
#include "hal_i2c_master.h"
#include "hal_i2c_slave.h"
#include "hal_spi_master.h"
#include "hal_spi_slave.h"
#include "tau_log.h"
#include "tau_delay.h"

#if 1//def AP_TP_TRANSFER
uint8_t read_point;							//ǰҪıһ8BYTE
uint8_t s_screen_number[2];
uint8_t s_screen_temp[2];
uint8_t s_screen_read_bak[80];
static uint8_t s_screen_read_buffer[BUFFER_SIZE_MAX];
static uint8_t s_phone_read_buffer[BUFFER_SIZE_MAX];

const  uint8_t *s_slave_txbuffer = NULL;
static size_t s_slave_txbuffer_size = 0;

static bool    s_spim_write = false;                   //¼SPIǷ÷ͣǵĻҪRXFIFO
static bool    s_screen_int_flag = false;              //¼ǷյĻıж
static bool    s_phone_reset_flag = false;             //¼ǷյֻĿλź
static bool    s_screen_int_transfer_status = false;   //¼ǷѾʼͨ
bool    s_screen_init_complate = false;         		//ĻTPʼɱ־
static uint8_t s_screen_const_transfer_count = 0xff;   //¼ǰͨŵһ,ʼֵ screen_reg_start_data_size

#ifdef USE_FOR_SUMSUNG_S10
uint16_t u16TouchID;
#endif
static void app_tp_transfer_phone(size_t recieve_num);
//static void app_tp_reset_callback(void *data);
#if PHONE_SLAVE_TRANSFER_I2C                           //warning
    static void app_tp_i2cs_callback(e_i2c_s_int_status int_status, size_t recieve_num);
#endif
#if PHONE_SLAVE_TRANSFER_SPI                           //warning
    static void app_tp_spis_callback(hal_spis_event_e event, hal_spi_packet_info_t *packet_info);
#endif

st_tp_scan_data  tp_scan_data;

/**************************************************************************
* @name : app_tp_screen_int_callback
* @brief : screen ж ص
* @param[in] :
* @return :
* @retval :
**************************************************************************/
static void app_tp_screen_int_callback(void *data)
{
    s_screen_int_flag = true;
}

/**************************************************************************
* @name : app_tp_screen_int_lvl_low
* @brief : ȡ screen ж IO ƽ
* @param[in] :
* @return : trueIO Ϊ͵ƽ
* @retval :
**************************************************************************/
static bool app_tp_screen_int_lvl_low(void)
{
#if SCREEN_MASTER_TRANSFER_I2C
    return false;
#elif SCREEN_MASTER_TRANSFER_SPI
    return !hal_gpio_get_input_data(g_screen_input_int_pad); //ӦSPIͨŹżͻȻCS ͨ쳣
#else
    return false;
#endif
}

/**************************************************************************
* @name : app_tp_screen_int_init
* @brief : screen ж IO ʼ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
static void app_tp_screen_int_init(void)
{
    hal_gpio_set_pull_state(g_screen_input_int_pad, ENABLE, DISABLE);         // 1.
    hal_gpio_ctrl_eint(g_screen_input_int_pad, DISABLE);                      // 2.رж
    hal_gpio_init_eint(g_screen_input_int_pad, DETECT_FALLING_EDGE);          // 3.жϳʼ,TPһ㶼½شж
    hal_gpio_reg_eint_cb(g_screen_input_int_pad, app_tp_screen_int_callback); // 4.עص
    hal_gpio_ctrl_eint(g_screen_input_int_pad, ENABLE);                       // 5.ʹж
}

#if 0
/**************************************************************************
* @name : app_tp_phone_reset_init
* @brief : phone reset ж IO ʼ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
static void app_tp_phone_reset_init(void)
{
    /*0.Ϊ*/
    hal_gpio_init_input(g_phone_input_rst_pad);
    /*1.رж*/
    hal_gpio_ctrl_eint(g_phone_input_rst_pad, DISABLE);
    /*2.жϳʼ*/
    hal_gpio_init_eint(g_phone_input_rst_pad, DETECT_RISING_EDGE);
    /*3.עص*/
    hal_gpio_reg_eint_cb(g_phone_input_rst_pad, app_tp_reset_callback);
    /*4.ʹж*/
    hal_gpio_ctrl_eint(g_phone_input_rst_pad, ENABLE);
}
#endif

/**************************************************************************
* @name : app_tp_screen_init
* @brief : screen IO 䣬ʼʼ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void app_tp_screen_init(void)
{
    hal_gpio_init_output(g_screen_input_rst_pad, IO_LVL_HIGH);
    delayUs(200);
    hal_gpio_set_output_data(g_screen_input_rst_pad, IO_LVL_LOW);
    delayUs(200);
    hal_gpio_set_output_data(g_screen_input_rst_pad, IO_LVL_HIGH);
}

/**************************************************************************
* @name : app_tp_init
* @brief : ʼͨ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void app_tp_init(void)
{
#ifdef ADD_MCU_BD826
	hal_gpio_init_output(IO_PAD_TD_SPIM_MOSI, IO_LVL_HIGH); 	   //ʼTP_reset,	
	hal_gpio_init_input(IO_PAD_TD_SPIM_MISO);		
#endif

#ifdef DISABLE_TDDI_I2C_FUNCTION
	hal_gpio_set_mode(IO_PAD_TD_SPIM_CLK,IO_MODE_I2C1_SCL);
	hal_gpio_set_mode(IO_PAD_TD_SPIM_CSN,IO_MODE_I2C1_SDA);

	return;
#else	
	hal_gpio_set_pull_state(IO_PAD_TD_SPIM_CLK, ENABLE, DISABLE);
	hal_gpio_set_pull_state(IO_PAD_TD_SPIM_CSN, ENABLE, DISABLE);	
#endif

    //app_tp_phone_reset_init();                                        //ʼֻλIO
    app_tp_screen_int_init();                                         //screenж
#ifdef G_PHONE_INT_DEFAULT_LOW
	hal_gpio_init_output(g_phone_output_int_pad, IO_LVL_LOW);	  //phoneжIO
#else
    hal_gpio_init_output(g_phone_output_int_pad, IO_LVL_HIGH);    //phoneжIO
#endif 
    hal_gpio_init_output(g_screen_input_rst_pad, IO_LVL_HIGH);	 //ģTP RESET

#if SCREEN_MASTER_TRANSFER_I2C
    hal_i2c_m_dma_init(SCREEN_I2C_ADDRESS, SCREEN_I2C_ADDR_BITS, I2C_MASTER_SPEED);
#elif SCREEN_MASTER_TRANSFER_SPI
    hal_spi_m_dma_init(SPI_MASTER_SPEED, SCREEN_SPI_CPHA, SCREEN_SPI_CPOL);
#endif

#if PHONE_SLAVE_TRANSFER_I2C
    hal_i2c_s_init(CHIP_I2C_ADDRESS, CHIP_I2C_ADDR_BITS);
    hal_i2c_s_set_transfer(app_tp_i2cs_callback);
    hal_i2c_s_nonblocking_read(s_phone_read_buffer, BUFFER_SIZE_MAX); //ý buffer
#elif PHONE_SLAVE_TRANSFER_SPI
    hal_spi_slave_init(PHONE_SPI_CPHA, PHONE_SPI_CPOL, true);                                   // ʼspiԼdma
    hal_spi_slave_register_callback(app_tp_spis_callback);            // עص
    hal_spi_slave_auto_transfer_abort();                              // ֹͣ
    hal_spi_slave_flush_fifo();                                       // Flush FIFO

    /* ÿpacketԶ, circle       mode Ϊfalse, յbuffer     max sizeݺbufferٸ, packetɺûص    */
    hal_spi_slave_set_auto_rx_buffer(s_phone_read_buffer, BUFFER_SIZE_MAX, false); // auto   rx buffer
    hal_spi_slave_set_auto_tx_buffer(phone_reg_const_data[0].write_back, phone_reg_const_data[0].write_back_size, false);   // TX BUFFER

    hal_spi_slave_enable();                                           // spis
    hal_spi_slave_auto_transfer_start();                              // rxԶ
#endif

}

/**************************************************************************
* @name : app_tp_m_transfer_complate
* @brief : ȡͨ״̬
* @param[in] :
* @return :true: ͨ
* @retval :
**************************************************************************/
bool app_tp_m_transfer_complate(void)
{
#if SCREEN_MASTER_TRANSFER_I2C
    return hal_i2c_m_transfer_complate();
#elif SCREEN_MASTER_TRANSFER_SPI
    return hal_spi_m_get_transfer_complate();
#else
    return true;
#endif
}

/**************************************************************************
* @name : app_tp_s_transfer_complate
* @brief : ȡӻͨ״̬
* @param[in] :
* @return :true: ͨ
* @retval :
**************************************************************************/
bool app_tp_s_transfer_complate(void)
{
#if SCREEN_MASTER_TRANSFER_I2C
    return hal_i2c_s_write_complate() && hal_i2c_s_read_complate();
#elif SCREEN_MASTER_TRANSFER_SPI
    return !hal_spi_slave_busy();
#else
    return true;
#endif
}

/**************************************************************************
* @name : app_tp_m_write
* @brief : ͨŷʽ÷txbufferе
* @param[in] :txbuffer:  buffer ͷַ
* @param[in] :buffer_size:  buffer 
* @return :
* @retval :
**************************************************************************/
static void app_tp_m_write(const uint8_t *txbuffer, size_t buffer_size)
{
#if SCREEN_MASTER_TRANSFER_I2C
    hal_i2c_m_dma_write(txbuffer, buffer_size);
#elif SCREEN_MASTER_TRANSFER_SPI
    hal_spi_m_dma_write(txbuffer, buffer_size);
    s_spim_write = true;
#endif
}

/**************************************************************************
* @name : app_tp_m_read
* @brief : ͨŷʽ÷txbufferеݺrxbuffer
* @param[in] :cmd:  buffer ͷַ
* @param[in] :cmd_size:  buffer 
* @param[in] :data_buffer: ȡ buffer ͷַ
* @param[in] :data_size: ȡ buffer 
* @return :
* @retval :
**************************************************************************/
static void app_tp_m_read(const uint8_t *cmd, size_t cmd_size, uint8_t *data_buffer, size_t data_size)
{
#if SCREEN_MASTER_TRANSFER_I2C
    uint8_t i = 0;
    uint32_t address = 0;

    for (i = 0; i < cmd_size; i++)                          //ȽҪ͵ϵ address
    {
        address |= (uint32_t)cmd[i] << i * 8;
    }
    hal_i2c_m_dma_read(address, cmd_size, data_buffer, data_size);
#elif SCREEN_MASTER_TRANSFER_SPI
    hal_spi_m_dma_read(cmd, cmd_size, data_buffer, data_size);
#endif
}

/**************************************************************************
* @name : app_tp_s_write
* @brief : ͨŷʽ÷txbufferе
* @param[in] :txbuffer:  buffer ͷַ
* @param[in] :buffer_size:  buffer 
* @return :
* @retval :
**************************************************************************/
void app_tp_s_write(const uint8_t *txbuffer, size_t buffer_size)
{
#if PHONE_SLAVE_TRANSFER_I2C
    hal_i2c_s_dma_write(txbuffer, buffer_size);
#elif PHONE_SLAVE_TRANSFER_SPI
    //while (hal_spi_slave_busy());
    hal_spi_slave_auto_transfer_abort();
    hal_spi_slave_flush_fifo();
    hal_spi_slave_set_auto_tx_buffer(txbuffer, buffer_size, true);
    hal_spi_slave_auto_transfer_start();
#endif
}

/**************************************************************************
* @name : app_tp_s_read
* @brief : ͨŷʽrxbuffer
* @param[in] :rxBuffer: ȡ buffer ͷַ
* @param[in] :data_size: ȡ buffer 
* @return :
* @retval :
**************************************************************************/
void app_tp_s_read(void *rxBuffer, size_t data_size)
{
#if PHONE_SLAVE_TRANSFER_I2C
    hal_i2c_s_nonblocking_read(rxBuffer, data_size);
#endif
}

/**************************************************************************
* @name : app_tp_spis_callback
* @brief : SPI slave жϴ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
/*
#if PHONE_SLAVE_TRANSFER_I2C                //warning
//ԡint_status=0Ϊ=2ΪSTOP=1δԵ
//recieve_numΪյָ
static void app_tp_i2cs_callback(e_i2c_s_int_status int_status, size_t recieve_num)
{
#if 0 // 1: test
	if (int_status >2)
	{
		s_phone_read_buffer[2]=int_status;
		s_phone_read_buffer[3]=recieve_num;
		app_tp_m_write(s_phone_read_buffer, 4);
	}
#endif
    app_tp_transfer_phone(recieve_num);
}
#endif

*/
#if PHONE_SLAVE_TRANSFER_I2C                //warning
static void app_tp_i2cs_callback(e_i2c_s_int_status int_status, size_t recieve_num)
{
    static bool i2cs_transfer = true;       //ȷһֻͨһ
    if (i2cs_transfer)
    {
        i2cs_transfer = false;
        app_tp_transfer_phone(recieve_num);
    }
    if (int_status == I2C_S_INT_READ)
    {
        app_tp_s_write(s_slave_txbuffer, s_slave_txbuffer_size);
    }
    else if (int_status == I2C_S_INT_STOP)
    {
        i2cs_transfer = true;
    }
}
#endif


/**************************************************************************
* @name : app_tp_spis_callback
* @brief : SPI slave жϴ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
#if PHONE_SLAVE_TRANSFER_SPI                //warning
static void app_tp_spis_callback(hal_spis_event_e event, hal_spi_packet_info_t *packet_info)
{
    app_tp_transfer_phone(packet_info->packet_size);
}
#endif

#if 0
/**************************************************************************
* @name : app_tp_reset_callback
* @brief : ֻ IO临λжϴ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
static void app_tp_reset_callback(void *data)
{
    TAU_LOGD("app_tp_reset_callback\n");
    s_phone_reset_flag = true;
    app_tp_s_write(phone_reg_const_data[0].write_back, phone_reg_const_data[0].write_back_size);
#if PHONE_SLAVE_TRANSFER_SPI
    hal_gpio_set_output_data(IO_PAD_AP_INT, IO_LVL_LOW);
#endif
}
#endif

/**************************************************************************
* @name : app_tp_transfer_screen_const
* @brief : flowдscreen  screen ʼ
* @param[in] :
* @return :
* @retval :
*޸TP1ģʼ
*ִscreen_reg_start_data[]
**************************************************************************/
static void app_tp_transfer_screen_const(void)
{
//    static bool    screen_const_transfer_buffer_ready = true;            // buffer Ƿ׼
	uint8_t ii;

    /**** 1. жϵǰ״̬ͨѽ, ״̬ͨѽҿʼ̻δ****/
#if 0 // test
	uint8_t test_master_read_buffer[10] = {0x08, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19};
	uint8_t write_buffer[10] = {0x04, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19};

//	for (ii =0x20; ii<0x7F; ii++)
	{
		//hal_i2c_m_dma_init(ii, SCREEN_I2C_ADDR_BITS);
		//delayMs(100);
		if (hal_i2c_m_dma_write(write_buffer, 1))
		{
			//break;
		}
		while(!hal_i2c_m_transfer_complate());
		hal_i2c_m_dma_read(test_master_read_buffer, 1, test_master_read_buffer, 2);
	}
#endif


    if (app_tp_m_transfer_complate() && (s_screen_const_transfer_count < screen_reg_start_data_size))
    {
        if (s_spim_write)                                                //SPI дݺҪѽFIFOݶȻӰһζȡ
        {
            hal_spi_m_clear_rxfifo();
            s_spim_write = false;
        }

	#if 1
		
		#ifndef USE_FOR_SUMSUNG_S10
		for (ii =0; ii<screen_reg_start_data_size; ii++)
		{
            if (!screen_reg_start_data[ii].read_flag)     //ǰͨŲҪأֱд
            {
                app_tp_m_write(screen_reg_start_data[ii].buffer, screen_reg_start_data[ii].txbuffer_size);
            }
            else                                             //ǰͨҪأдٶ
            {
                app_tp_m_read(screen_reg_start_data[ii].buffer, screen_reg_start_data[ii].txbuffer_size, \
                              s_screen_read_bak, screen_reg_start_data[ii].rxbuffer_size);
            }
			while(!hal_i2c_m_transfer_complate());
		}
		#endif
		#if 0//
		delayMs(100);
		app_tp_m_read(screen_reg_int_data[0].buffer, screen_reg_int_data[0].txbuffer_size, s_screen_number, screen_reg_int_data[0].rxbuffer_size);
		while(!hal_i2c_m_transfer_complate());
		#endif
		s_screen_init_complate = true;
        printf("tp done\n");

	#else
        /**** 2. ͻȡӻ ****/
        if (screen_const_transfer_buffer_ready)
        {
            screen_const_transfer_buffer_ready = false;
            if (!screen_reg_start_data[s_screen_const_transfer_count].read_flag)     //ǰͨŲҪأֱд
            {
                app_tp_m_write(screen_reg_start_data[s_screen_const_transfer_count].buffer, screen_reg_start_data[s_screen_const_transfer_count].txbuffer_size);
            }
            else                                                             //ǰͨҪأдٶ
            {
                app_tp_m_read(screen_reg_start_data[s_screen_const_transfer_count].buffer, screen_reg_start_data[s_screen_const_transfer_count].txbuffer_size, \
                              s_screen_number, screen_reg_start_data[s_screen_const_transfer_count].rxbuffer_size);
            }
			s_screen_init_complate = true;
        }
        /**** 3. ͨݣ׼һͨŵbuffer ****/
        else
        {
            screen_const_transfer_buffer_ready = true;
            s_screen_const_transfer_count = app_tp_screen_analysis_const(s_screen_const_transfer_count, s_screen_number, \
                                            screen_reg_start_data[s_screen_const_transfer_count].rxbuffer_size);

            if (s_screen_const_transfer_count >= screen_reg_start_data_size)
            {
                s_screen_init_complate = true;
            }
        }
	#endif	
    }
}

/**************************************************************************
* @name : app_tp_transfer_screen_start
* @brief : flowдscreenʼʼ
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void app_tp_transfer_screen_start(void)
{
    s_screen_init_complate = false;
    s_screen_const_transfer_count = 0;
    //app_tp_screen_init();
#ifndef DISABLE_I2C_INIT_CODE    
    app_tp_transfer_screen_const();
#endif
	s_screen_int_flag = false;
}

/**************************************************************************
* @name : app_tp_transfer_screen_int
* @brief : screenжϺ󣬰flowдscreenЭת
* @param[in] :
* @return :
* @retval :
*޸TP2ȡģ鱨㣡
*ִscreen_reg_int_data[]ҲԼд
**************************************************************************/
void app_tp_transfer_screen_int(void)
{
    bool screen_gpio_int = false;
    static uint8_t screen_int_transfer_count = 0;            //¼ǰͨŵһ
    static bool    screen_int_transfer_buffer_ready = true;  // buffer Ƿ׼
//    static uint8_t test_flag = 0;
	
    if (!s_screen_init_complate)                             //TP ʼδɣȽгʼ
    {
        app_tp_transfer_screen_const();
        return;
    }

#if 0 //test
	test_flag++;
	if (test_flag >1000000)
	{
		test_flag =0;
		//TAU_LOGD("Run ok!!\n");
		//app_tp_m_read(screen_reg_int_data[0].buffer, screen_reg_int_data[0].txbuffer_size, s_screen_number, screen_reg_int_data[0].rxbuffer_size);
		//while(!hal_i2c_m_transfer_complate());
	}
#endif

    /**** 1. ж screen Ƿ񷢳жź ****/
    // s_screen_int_flag:           жźű־λ
    // app_tp_screen_int_lvl_low :  SPI ʱͨʱżcsߵͨ쳣ñ־λڽ
    screen_gpio_int = s_screen_int_flag || app_tp_screen_int_lvl_low();
    if (((screen_gpio_int) || (s_screen_int_transfer_status)) && app_tp_m_transfer_complate()) //жϵǰͨ״̬׼ͨ
    {
 //   	TAU_LOGD("touch ok!!\n");
        s_screen_int_flag = false;
        if (s_spim_write)                                    //SPI дݺҪѽFIFOݶȻӰһζȡ
        {
            hal_spi_m_clear_rxfifo();
            s_spim_write = false;
        }

        /**** 2. ͻȡӻ ****/
        if (screen_int_transfer_buffer_ready)
        {
		#ifndef READ_MODULE_TP_ONE_BY_ONE
			screen_int_transfer_buffer_ready = false;
			s_screen_int_transfer_status = true;
		#ifdef USE_FOR_SUMSUNG_S10
			app_tp_m_read(screen_reg_int_data[2].buffer, 1, s_screen_read_buffer, 64);
	//		app_tp_m_read(screen_reg_int_data[2].buffer, 1, s_screen_read_buffer, 8);
			while(!hal_i2c_m_transfer_complate());
			
		#else		
			app_tp_m_read(screen_reg_int_data[0].buffer, screen_reg_int_data[0].txbuffer_size, s_screen_temp, screen_reg_int_data[0].rxbuffer_size);
			while(!hal_i2c_m_transfer_complate());
			app_tp_m_read(screen_reg_int_data[1].buffer, screen_reg_int_data[1].txbuffer_size, s_screen_number, screen_reg_int_data[1].rxbuffer_size);
			while(!hal_i2c_m_transfer_complate());
			//TAU_LOGD("s_screen_number[%4x], size[%4x]", ((s_screen_number[1]<<8)|s_screen_number[0]), ((s_screen_temp[1]<<8)|s_screen_temp[0]));
			
			if(s_screen_number[1])
			{
				if (s_screen_number[1]>3)
				{
					read_point =1;
					s_screen_int_transfer_status = false;
				}
				else if (s_screen_number[1] &0x02)
					read_point =10;
				else
					read_point =9;
			}
			else
			{
				if(s_screen_number[0] &0x80)
					read_point =8;
				else if(s_screen_number[0] &0x40)
					read_point =7;
				else if(s_screen_number[0] &0x20)
					read_point =6;
				else if(s_screen_number[0] &0x10)
					read_point =5;
				else if(s_screen_number[0] &0x08)
					read_point =4;
				else if(s_screen_number[0] &0x04)
					read_point =3;
				else if(s_screen_number[0] &0x02)
					read_point =2;
				else
					read_point =1;
			}
			read_point =8*read_point;
			app_tp_m_read(screen_reg_int_data[2].buffer, screen_reg_int_data[2].txbuffer_size, s_screen_read_buffer, read_point);
			while(!hal_i2c_m_transfer_complate());
		#endif	
		#else
            if (!screen_reg_int_data[screen_int_transfer_count].read_flag)  //ǰͨŲҪأֱд
            {
                app_tp_m_write(screen_reg_int_data[screen_int_transfer_count].buffer, screen_reg_int_data[screen_int_transfer_count].txbuffer_size);
            }
            else                                                            //ǰͨҪأдٶ
            {
				s_screen_int_transfer_status = true;
            	if (screen_int_transfer_count==0)
            	{
	                app_tp_m_read(screen_reg_int_data[screen_int_transfer_count].buffer, screen_reg_int_data[screen_int_transfer_count].txbuffer_size, \
	                              s_screen_temp, screen_reg_int_data[screen_int_transfer_count].rxbuffer_size);
					screen_int_transfer_count =1;
            	}
            	else if (screen_int_transfer_count==1)
            	{
	                app_tp_m_read(screen_reg_int_data[screen_int_transfer_count].buffer, screen_reg_int_data[screen_int_transfer_count].txbuffer_size, \
	                              s_screen_number, screen_reg_int_data[screen_int_transfer_count].rxbuffer_size);
					screen_int_transfer_count =2;
            	}
            	else if (screen_int_transfer_count==2)
            	{
					if(s_screen_number[1])
					{
						TAU_LOGD("s_screen_number[%4x], size[%4x]", ((s_screen_number[1]<<8)|s_screen_number[0]), ((s_screen_temp[1]<<8)|s_screen_temp[0]));
						if (s_screen_number[1] &0x02)
							read_point =10;
						else
							read_point =9;
					}
					else
					{
						if(s_screen_number[0] &0x80)
							read_point =8;
						else if(s_screen_number[0] &0x40)
							read_point =7;
						else if(s_screen_number[0] &0x20)
							read_point =6;
						else if(s_screen_number[0] &0x10)
							read_point =5;
						else if(s_screen_number[0] &0x08)
							read_point =4;
						else if(s_screen_number[0] &0x04)
							read_point =3;
						else if(s_screen_number[0] &0x02)
							read_point =2;
						else
							read_point =1;
					}
					read_point =8*read_point;
					
	                app_tp_m_read(screen_reg_int_data[screen_int_transfer_count].buffer, screen_reg_int_data[screen_int_transfer_count].txbuffer_size, \
	                              s_screen_read_buffer, read_point);
					screen_int_transfer_count =0;
					screen_int_transfer_buffer_ready = false;
            	}
            }
		#endif	
        }
        /**** 3. ͨݣ׼һͨŵbuffer ****/
        else
        {
        #if 1
			#ifdef USE_FOR_SUMSUNG_S10
			u16TouchID=0x0000;
			#endif	
			screen_int_transfer_buffer_ready = true;
			screen_int_transfer_count = app_tp_screen_analysis_int(screen_int_transfer_count, s_screen_read_buffer,screen_reg_int_data[2].rxbuffer_size);
			screen_int_transfer_count = 0;
			s_screen_int_transfer_status = false;

		#else
            screen_int_transfer_buffer_ready = true;
            screen_int_transfer_count = app_tp_screen_analysis_int(screen_int_transfer_count, s_screen_read_buffer, \
                                        screen_reg_int_data[screen_int_transfer_count].rxbuffer_size);

            if (screen_int_transfer_count > screen_reg_int_data_size)       //ҪһͨŽһݽֹͣͨ
            {
                screen_int_transfer_count = 0;
                s_screen_int_transfer_status = false;
                return;
            }
		#endif	
        }
    }
}

/**************************************************************************
* @name : app_tp_transfer_phone
* @brief : ݽӦĴ
* @param[in] : recieve_numݳ
* @return :
* @retval :
**************************************************************************/
static void app_tp_transfer_phone(size_t recieve_num)
{
 //   const uint8_t *phone_write_buffer;
 //   size_t phone_write_buffer_size = 0;
    /* ݽжǷҪԼ𸴵bufferָ */
    if (recieve_num > 0)
    {
    #if 0// 1: test
		s_phone_read_buffer[3]=recieve_num;
		app_tp_m_write(s_phone_read_buffer, 4);
	#endif
   //     app_tp_phone_analysis_data(s_phone_read_buffer, recieve_num, &phone_write_buffer, &phone_write_buffer_size);
//		app_tp_phone_analysis_data(s_phone_read_buffer, recieve_num, &s_slave_txbuffer, &s_slave_txbuffer_size);
		app_tp_phone_analysis_data_custom(s_phone_read_buffer, recieve_num, s_slave_txbuffer, &s_slave_txbuffer_size);
	//	printf("222    %p %x \n",*s_slave_txbuffer,s_slave_txbuffer_size);
    }

    app_tp_s_read(s_phone_read_buffer, BUFFER_SIZE_MAX);
 /*   if (phone_write_buffer_size)                                      //0ʾҪֻ÷buffer
    {
        app_tp_s_write(phone_write_buffer, phone_write_buffer_size);
    }
 */
}

void ap_tp_scan_point_init(void)
{
	uint8_t i=0;
	
	for(i=0;i<ST_TP_SCAN_POINT_NUMBER_MAX;i++)
	tp_scan_data.tp_point_buffer[i] = 0;
	tp_scan_data.tp_point_up_error_flag = 0;
	tp_scan_data.tp_read_point_counter = 0;
	tp_scan_data.tp_point_error_time_counter = 0;
}

void ap_tp_scan_point_record_event_exec(void)
{
	if(tp_scan_data.tp_point_up_error_flag == 1)
	{
		if(tp_scan_data.tp_point_error_time_counter < (65536/10))  // 65536*3 = 900ms  65536/10 = 30ms
		{
	        tp_scan_data.tp_point_error_time_counter ++;
	    }
		else	// ûյmove release ʱ䳬ʱ
		{
//			tp_scan_data.tp_point_up_error_flag = 0;
//			tp_scan_data.tp_point_error_time_counter = 0;
			if(tp_scan_data.tp_read_point_counter>0)	// в
			{
				printf("release finger %2d\n",tp_scan_data.tp_read_point_counter);
		        tp_scan_data.tp_read_point_counter = 0;
	//			ap_tp_simulate_finger_release_event();
			}

			ap_tp_scan_point_init();
	    }
	}
	
}


/**************************************************************************
* @name : app_tp_phone_reset_on
* @brief : ȡֻλźŵ״̬
* @param[in] :
* @return :
* @retval :
**************************************************************************/
bool app_tp_phone_reset_on(void)
{
    return s_phone_reset_flag;
}

/**************************************************************************
* @name : app_tp_phone_clear_reset_on
* @brief : ֻλźŵ״̬
* @param[in] :
* @return :
* @retval :
**************************************************************************/
void app_tp_phone_clear_reset_on(void)
{
    s_phone_reset_flag = false;
}

#else

void app_tp_screen_init(void)
{

}

void app_tp_init(void)
{

}

void app_tp_transfer_screen_int(void)
{

}

void app_tp_transfer_screen_start(void)
{

}

bool app_tp_phone_reset_on(void)
{
    return false;
}

void app_tp_phone_clear_reset_on(void)
{

}

void app_tp_s_write(const uint8_t *txbuffer, size_t buffer_size)
{

}

bool app_tp_enter_sleep_on(void)
{
    return false;
}

#endif

