/*******************************************************************************
*
* File:         s8_demo.c
* Description:  ϵͳļ
* Version:      V0.1
* Date:         2020-02-22
* Author:       Tempest
 *******************************************************************************/

#include "ap_demo.h"
#include "ArmCM0.h"
#include "tau_device_datatype.h"
#include "tau_log.h"
#include "tau_operations.h"
#include "tau_common.h"
#include "tau_delay.h"
#include "hal_dsi_rx_ctrl.h"
#include "hal_dsi_tx_ctrl.h"
#include "hal_swire.h"
#include "hal_timer.h"
#include "hal_system.h"
#include "hal_gpio.h"
#include "hal_pwm.h"
#include "app_tp_transfer.h"


#ifdef LOG_TAG
    #undef LOG_TAG
#endif

#define LOG_TAG "Mi8SE"

#define LCD_FT8006S_HKC6517 	1

#define SHARE_FLASH_MODE 1

//ֻMIPIϢ
/* ֱ */
#define INPUT_WIDTH  1080
#define INPUT_HEIGHT 2244
/*  MIPI lane rate,video modeҪȷãcmd mode */
#define INPUT_MIPI_LANE_RATE 1100000000   //600000000 // Note10 Pro 600M-1.2G
/* ͼʽ */
#define INPUT_COLOR_MODE DSI_RGB888
/* ݸʽ(DSI_DATA_CMD_MODE , DSI_DATA_VIDEO_MODE) */
#define INPUT_DATA_MODE DSI_DATA_CMD_MODE
/* mipi lane(DSI_RX_LANE_x     xΪ1-4) */
#define INPUT_MIPI_LANE_NUM DSI_LANE_4
/* Ϊvideo mode ʱݸʽ */
#define INPUT_VIDEO_MODEL DSI_NONBURST_EVENT
/* ͨ(0-3) */
#define INPUT_VC DSI_VC_0
/* ֡(60/90/120/144Hz) */
#define INPUT_FRAME_RATE DSI_FRAME_RATE_60HZ
/* ǷDSCѹ */
#define INPUT_COMPRESS false

#if LCD_FT8006S_HKC6517
#if 1
//LCD HX8394?3?MIPIy?YD??
/* ?3???????? */
#define OUTPUT_WIDTH 720
#define OUTPUT_HEIGHT 1600
/* ?3?D?ą(0-3) */
#define OUTPUT_VC DSI_VC_0
/* ?3?mipi laney?(DSI_RX_LANE_x	   x?a1-4) */
#define OUTPUT_LANE_NUMBER DSI_LANE_4
/* ?3??avideo mode ?y?Y??? */
#define OUTPUT_VIDEO_MODEL   DSI_BURST_MODE              // DSI_NONBURST_EVENT
/* ?3? VSA */
#define OUTPUT_VSA	 8//8      //8 //2     //4
/* ?3? VBP */
#define OUTPUT_VBP	 110//40    //110 //4     //16
/* ?3? VBP */
#define OUTPUT_VFP	 130 //130  //240  //46 

#define OUTPUT_HSA	 16//20   //16  //7     //10 
/* ?3? HBP */
#define OUTPUT_HBP	 30 //45 //140    //16
/* ?3? HFP */
#define OUTPUT_HFP	 45//148  //48 //48     //46
/* 3????꨺?????D */
#define _CMD_TYPE			 DSI_CMD_TX_LP		//0-HS,1-LP;

#else
    //TDDI FT8006SMIPIϢ
    /* ֱ */
    #define OUTPUT_WIDTH 720
    #define OUTPUT_HEIGHT 1600
    /* ͨ(0-3) */
    #define OUTPUT_VC DSI_VC_0
    /* mipi lane(DSI_RX_LANE_x     xΪ1-4) */
    #define OUTPUT_LANE_NUMBER DSI_LANE_4
    /* Ϊvideo mode ݸʽ */
    #define OUTPUT_VIDEO_MODEL DSI_BURST_MODE
    /*  VSA */
    #define OUTPUT_VSA  8
    /*  VBP */
    #define OUTPUT_VBP  110
    /*  VBP */
    #define OUTPUT_VFP  130
    /*  VSA */
    #define OUTPUT_HSA  16
    /*  HBP */
    #define OUTPUT_HBP  45
    /*  HFP */
    #define OUTPUT_HFP  48
    /* ʼģʽ */
    #define _CMD_TYPE            DSI_CMD_TX_LP      //0-HS,1-LP;
#endif

#endif

#define SWIRE_TIMER TIMER_NUM1
#define TE_TIMER    TIMER_NUM2

// #define DISABLE_TDDI_I2C_FUNCTION   1
/******************************************************/
static hal_dsi_rx_ctrl_handle_t *g_rx_ctrl_handle = NULL;
static hal_dsi_tx_ctrl_handle_t *g_tx_ctrl_handle = NULL;

/* Ĭfalse,ʼ־λ,ʹTP1.8V,AC ʼҪTP1.8Vе */
#if 0//def USE_FOR_SUMSUNG_S10
static volatile bool start_display_on = false;
#else
static volatile bool start_display_on = true;
#endif
/* ʼɱ־λ */
static volatile bool panel_display_done = false;
static volatile bool g_resolution_change = false;

//static bool swire_flag=false;

static uint8_t swire_num=38; //38 // 14-->ELVSS -4.1v test BOARD
//static uint8_t swire_num_bak=38;

#define PWM_PERIOD           256   //PWM.λUS
#define PWM_MIN		 		 12		//Сֵɵ
#define SWIRE_MAX_NUM		 22 //  14-->8.8V //S10 22


/* B1ص      g_cus_rx_dcs_execute_table Ϊ첽ִУCAͬ*/

uint16_t read_bl_data = 0;     //ݲͬӳBLֵ1~255
uint16_t read_bl_data_bak = 0;

#if 1 //
#define BLUE_MAX			0xF0	//ֵ
#define BLUE_MIN			0x86	//Сֵ
#define BLUE_STEP			10		//ȼ-1
#endif

static uint32_t loop_count =0;

//bool s_screen_init_complate; 

//void swire_init();

////#define NEW_ACK_CMD_FUNC		 //For s9+ test. change LIB
uint32_t rx_filter_1080_h_4_70[32][2] =
{
    0xE0F9503E, 0x0000000E,
    0xE10D5039, 0x0000000E,
    0xE9214E34, 0x0000000E,
    0xE9354E2F, 0x0000000E,
    0xF1494C2A, 0x0000000E,
    0xF95D4A25, 0x0000000E,
    0x01714820, 0x0000000F,
    0x1185421C, 0x0000000F,
    0x21954017, 0x0000000F,
    0x29A93C13, 0x0000000F,
    0x39BD380E, 0x0000000F,
    0x51CD320A, 0x0000000F,
    0x61E12C06, 0x0000000F,
    0x79F12602, 0x0000000F,
    0x92011FFF, 0x0000000F,
    0xAA1119FB, 0x0000000F,
    0xC22111F8, 0x0000000F,
    0xDA3109F5, 0x0000000F,
    0xFA3D01F2, 0x0000000F,
    0x124CF9EF, 0x00000000,
    0x3258F1EC, 0x00000000,
    0x5264E7EA, 0x00000000,
    0x7270DFE7, 0x00000000,
    0x9A78D5E5, 0x00000000,
    0xBA80CBE4, 0x00000000,
    0xE284C3E2, 0x00000000,
    0x0290B9E0, 0x00000001,
    0x2A94AFDF, 0x00000001,
    0x5298A5DE, 0x00000001,
    0x7A9C9BDD, 0x00000001,
    0xA29C91DD, 0x00000001,
    0xCAA087DC, 0x00000001
};


uint32_t rx_filter_2240_v_4_70[32][2] =
{
    0xE0F9503E, 0x0000000E,
    0xE10D5039, 0x0000000E,
    0xE9214E34, 0x0000000E,
    0xE9354E2F, 0x0000000E,
    0xF1494C2A, 0x0000000E,
    0xF95D4A25, 0x0000000E,
    0x01714820, 0x0000000F,
    0x1185421C, 0x0000000F,
    0x21954017, 0x0000000F,
    0x29A93C13, 0x0000000F,
    0x39BD380E, 0x0000000F,
    0x51CD320A, 0x0000000F,
    0x61E12C06, 0x0000000F,
    0x79F12602, 0x0000000F,
    0x92011FFF, 0x0000000F,
    0xAA1119FB, 0x0000000F,
    0xC22111F8, 0x0000000F,
    0xDA3109F5, 0x0000000F,
    0xFA3D01F2, 0x0000000F,
    0x124CF9EF, 0x00000000,
    0x3258F1EC, 0x00000000,
    0x5264E7EA, 0x00000000,
    0x7270DFE7, 0x00000000,
    0x9A78D5E5, 0x00000000,
    0xBA80CBE4, 0x00000000,
    0xE284C3E2, 0x00000000,
    0x0290B9E0, 0x00000001,
    0x2A94AFDF, 0x00000001,
    0x5298A5DE, 0x00000001,
    0x7A9C9BDD, 0x00000001,
    0xA29C91DD, 0x00000001,
    0xCAA087DC, 0x00000001
};


static bool ap_dcs_read(uint8_t data_type, uint8_t dcs_cmd, uint8_t param)
{
    TAU_LOGD("cmd=%x\n", dcs_cmd);
	return true;
}
#if 1

/*****************************************************************************
* @brief  pwmԿƱ
* @param  init:     ǷΪʼһαѡʼ
* @param  polarity: ԣfalse:ȸߺͣtrue:ȵͺ
* @param  duty_ratio: ռձ(0-100)
* @param  frequency: ƵʣλHZ
* @retval null
*****************************************************************************/
//static void test_pwm_out_adjust(bool init, bool polarity, uint8_t duty_ratio, uint32_t frequency)
//{

//    pwm_out_ctrl_e ctl0 = PWMO_CTRL_HIGH;
//    pwm_out_ctrl_e ctl1 = PWMO_CTRL_LOW;
//    if(polarity)
//    {
//        ctl0 = PWMO_CTRL_LOW;
//        ctl1 = PWMO_CTRL_HIGH;
//    }
//    uint32_t period = 1000000 / frequency; //λus
//    uint32_t thr0 = 0;
//    uint32_t thr1 = (period * duty_ratio / 100);

//    if(duty_ratio == 100)
//    {
//        ctl1 = ctl0;
//        thr1 = period / 2;
//    }
//    if(init)
//    {
//        hal_pwm_out_init();
//        hal_pwm_out_config_all(ctl0, ctl1, thr0, thr1, period);
//    }
//    else
//    {
//        hal_pwm_out_sync_all(ctl0, ctl1, thr0, thr1, period);
//    }
//}
static void PWM_init(void)
{
    // 1ms ڳʼ͵ƽ1000
    hal_pwm_out_init();
    hal_pwm_out_config_all(PWMO_CTRL_HIGH, PWMO_CTRL_LOW, PWM_PERIOD, 0, PWM_PERIOD);
//	hal_pwm_out_config_all(PWMO_CTRL_HIGH, PWMO_CTRL_LOW, PWM_PERIOD/2, 0, PWM_PERIOD);
}

void PWM_Task(void)
{
    uint16_t pwm_h;

#if 0 // NOTE10ий绰Ϩ
    if(Flag_blacklight_EN)
    {
        read_bl_data_bak = 0;
        hal_pwm_out_sync_thr(PWM_PERIOD + 1, 0);
        return;
    }
#endif

#if 1//
    if(read_bl_data != read_bl_data_bak)
    {
        read_bl_data_bak = read_bl_data;
        pwm_h = read_bl_data ;

        if(pwm_h < PWM_MIN)
            pwm_h = PWM_MIN;
        hal_pwm_out_sync_thr(0, pwm_h);
    }
#endif

}
#endif

/* PPS update callback ڷֱлcase */
static bool pps_update_handle(uint8_t *pps, uint8_t size, uint32_t pic_width, uint32_t pic_height)
{
    /* AVDD ϵ, ڽϢPPS */
 //   hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
//		hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
    if (pic_width != g_rx_ctrl_handle->base_info.src_w || pic_height != g_rx_ctrl_handle->base_info.src_h)
    {
		
        /* PPS Update ҷֱʷ仯 */
        g_rx_ctrl_handle->base_info.src_w = pic_width;
        g_rx_ctrl_handle->base_info.src_h = pic_height;
				g_rx_ctrl_handle->compress_en = true;
        /* עⲿֻPPSǰ Compression Mode Command */
   
        g_tx_ctrl_handle->base_info.src_w = pic_width;
        g_tx_ctrl_handle->base_info.src_h = pic_height;

        hal_dsi_rx_ctrl_toggle_resolution(g_rx_ctrl_handle);
//            hal_dsi_rx_ctrl_set_auto_hw_filter(g_rx_ctrl_handle, true);

//        hal_dsi_rx_ctrl_toggle_resolution(g_rx_ctrl_handle);
//        TAU_LOGD("resolution update w[%d] h[%d] compress[%d]\n", pic_width, pic_height, g_rx_ctrl_handle->compress_en);
    }
//		hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
 //   hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
//    TAU_LOGD("PPS Update\n");
    return true;
}

static bool ap_set_display_on(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    
    TAU_LOGD("disp on \n");
    return true;
}

static bool ap_set_display_off(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    
    //delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x28);
    TAU_LOGD("disp off \n");
//    hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_LOW);
//	hal_gpio_set_output_data(IO_PAD_AP_SWIRE, IO_LVL_LOW);
//	hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_LOW);
//    hal_swire_open(DISABLE);
    return true;
}

static bool ap_set_enter_sleep_mode(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    TAU_LOGD("enter sleep mode\n");
   // delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x10);
	
	hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_LOW);
	hal_gpio_set_output_data(IO_PAD_AP_SWIRE, IO_LVL_LOW);
	hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_LOW);
	
	hal_pwm_out_sync_thr(PWM_PERIOD + 1, 0);

//	hal_system_set_vcc(false);
	
    return true;
}

static bool ap_set_exit_sleep_mode(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
{
    TAU_LOGD("exit sleep mode\n");
    /* AVDD ϵ, ڽϢPPS */
 //   hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
    return true;
}

#if 1 //
static bool ap_set_backlight(hal_dsi_rx_ctrl_handle_t* handler, hal_dcs_packet_t* dcs_packet)
{
    uint32_t	temp_in_max =  0x3FF;
    uint32_t	temp_in_min =   0x08;
    uint32_t	temp_out_max = 255;
    uint32_t	temp_out_min = 12;
    uint32_t src_bl;

    src_bl = (dcs_packet->packet_param[0] << 8) | dcs_packet->packet_param[1];
//   TAU_LOGD("src_bl[%x]. len[%d]", src_bl ,dcs_packet->param_length);

    if(src_bl <= temp_in_min)
        src_bl = temp_in_min;
    else if(src_bl >= temp_in_max)
        src_bl = temp_in_max;

    read_bl_data = temp_out_min + (src_bl - temp_in_min) * (temp_out_max - temp_out_min) / (temp_in_max - temp_in_min);
//    TAU_LOGD("read_bl_data[%4x]", read_bl_data);
    return true;
}
#endif

static void soft_te_timer_cb(void *data)
{
    /*
        S8 ӵTP1.8V, AC ҪȵTP1.8 ٳʼ, TP ǰҪͨTEֻֻ
    */
    if (panel_display_done == false)
    {
        hal_dsi_rx_ctrl_gen_a_tear_signal(g_rx_ctrl_handle);
        hal_timer_start(TE_TIMER, 17, soft_te_timer_cb, NULL);
    }
    else
    {
        hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
    }
}

static void soft_te_timer_init()
{
    TAU_LOGD("soft_te_timer_init\n");
    hal_dsi_rx_ctrl_set_sw_tear_mode(g_rx_ctrl_handle);
    hal_timer_init(TE_TIMER);
    hal_timer_start(TE_TIMER, 1, soft_te_timer_cb, NULL);
}

//static bool ap_set_tear_on(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
//{
//    if (panel_display_done == true)
//    {
//        hal_dsi_rx_ctrl_set_hw_tear_mode(g_rx_ctrl_handle);
//    }
//    else
//    {
//        soft_te_timer_init();
//    }
//    TAU_LOGD("ap_set_tear_on\n");
//    return true;
//}

//static bool ap_set_pps_9e(hal_dsi_rx_ctrl_handle_t *handler, hal_dcs_packet_t *dcs_packet)
//{
//    TAU_LOGD("9E \n");
// //   hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_LOW);
// //   hal_swire_open(DISABLE);
//    return true;
//}

/* ƻDCS command  */
static const hal_dcs_execute_entry_t g_cus_rx_dcs_execute_table[] =
{
    {DCS_SET_DISPLAY_ON, ap_set_display_on, true},
    {DCS_SET_DISPLAY_OFF, ap_set_display_off, true},
//		{0x9E, ap_set_pps_9e, true},
 //    {DCS_SET_TEAR_ON, ap_set_tear_on, true},
//	{0xDF, ap_get_reg_df, false},  //
//	{0xCA, ap_get_reg_ca, false},  // ⡣ҪB1ܵ
    {0x51, ap_set_backlight, false},
    {DCS_ENTER_SLEEP_MODE, ap_set_enter_sleep_mode, true},
    {DCS_EXIT_SLEEP_MODE, ap_set_exit_sleep_mode, true},
    {0, NULL, false}                        //{0,NULL,false} һ̶ԱΪtableβжϱ׼
};

static void tx_panel_reset(void)
{
#ifdef USE_WL518_INTERNAL_FLASH	
	hal_system_share_flash_mode(true);//*******************************************ǷҪflash,򿪵ĻҪFLASHֱӽBINļ¼518,رҪFLASH
#endif

    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
    delayMs(10);                //10ms
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_LOW);
    delayMs(10);                //10ms
    hal_dsi_tx_ctrl_panel_reset_pin(IO_LVL_HIGH);
    delayMs(30);
}

//#define  FT8006S_HKC6517_4L_720x1600_gamma22	0
//#define  FT8006S_HKC6517_4L_720x1600_gamma25	0

static void init_panel(void)
{
    /* reset panel*/
    tx_panel_reset();

    hal_gpio_init_output(IO_PAD_TD_LEDPWM, IO_LVL_HIGH);

    /* enter send initial code mode*/
    hal_dsi_tx_ctrl_enter_init_panel_mode();

			//-------------  Display Initial Setting end -------------------------
#if LCD_FT8006S_HKC6517
	TAU_LOGD("Mi8SE\n");
#ifdef FT8006S_HKC6517_4L_720x1600_gamma25
	
	delayMs(50);
//	delayMs(1000);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x41,0x5A);
	//INT CANCEL
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x4C, 0x03);

	//SPI Not LoadFinish
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x24);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x90,0x5A);
	//VCOM
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x03);
//	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x80,0x1A,0x01);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x80, 0x3f, 0x01);
	//Blank 8
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x08);
//	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,4,0x80,0x1A,0x2D,0x05);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,4,0x80,0x3F,0x2D,0x05);
	//Blank 9
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x09);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x5A,0x51,0xB5,0x2A,0x6C,0xE5,0x4A,0x01,0x40,0x62,0x0F,0x82,0x20,0x08,0xF0,0xB7);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x00,0x24,0x42,0x0A,0xE3,0x91,0xA4,0xF0,0xD6,0xC3,0x70,0x20,0x2D,0xA1,0x26,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0x51,0x55,0x55,0x00,0xA0,0x4D,0x06,0x11,0x0D,0x60,0x00,0xFF,0xFF,0x03,0xA5,0xE6);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0x08,0x3A,0x12,0x64,0x0B,0x00,0x00,0x11,0x00,0x60,0x00,0xFF,0xFF,0x03,0xFF,0x34);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,9,0xC0,0x0C,0xFF,0x18,0x9F,0x0F,0x00,0x08,0x00);
	//Blank 10	gamma2.2
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0A);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xFF,0xB6,0x6D,0x03,0x00,0x12,0x20,0x32,0x45,0x58,0x60,0x96,0x82,0xC1,0x72,0x37);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x74,0x44,0x41,0x32,0x23,0x16,0x0E,0x0B,0x00,0x12,0x20,0x32,0x45,0x58,0x60,0x96);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,14,0xA0,0x82,0xC1,0x72,0x37,0x74,0x44,0x41,0x32,0x23,0x16,0x0E,0x0B,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0B);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x00,0x20,0x44,0x08,0x00,0x60,0x47,0x00,0x00,0x10,0x22,0x04,0x00,0xB0,0x23);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x90,0x15,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0C);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xBA,0x68,0x68,0x01,0x32,0x4B,0x58,0x07,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x15,0x55,0x61,0x15,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51,0x15,0x55,0x61,0x95);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0xAB,0x18,0x00,0x05,0x00,0x05,0x00,0x05,0x00,0x49,0x29,0x84,0x52,0x01,0x09,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0xB0,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0D);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,8,0x80,0xF0,0xB1,0x71,0xEF,0x4B,0xC0,0x80);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0E);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,9,0x80,0xFF,0x01,0x55,0x55,0x23,0x88,0x88,0x1C);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0F);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xBD,0x07,0x70,0xC0,0x12,0x08,0x64,0x08,0x52,0x51,0x58,0x49,0x03,0x52,0x4C,0x4C);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x68,0x68,0x68,0x4C,0x4C,0x7C,0x14,0x00,0x20,0x06,0xC2,0x00,0x04,0x06,0x0C,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,5,0xA0,0x00,0x92,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x10);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x00,0x03,0xE7,0x1F,0x17,0x10,0x48,0x80,0xAA,0xD0,0x18,0x30,0x88,0x41,0x8A);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,16,0x90,0x39,0x28,0xA9,0xC5,0x9A,0x7B,0xF0,0x07,0x7E,0xE0,0x07,0x7E,0x20,0x10,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x11);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x46,0x77,0x03,0x40,0xCA,0xF3,0xFF,0x83,0x30,0x08,0xC4,0x06,0xA1,0xD8,0x24,0x18);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x30,0xC6,0x66,0xC1,0x80,0x31,0x15,0xCB,0xE5,0xD2,0x68,0x6C,0x36,0x1D,0x04,0xC8);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0xB0,0xD9,0x88,0x60,0xB0,0x81,0x40,0x1A,0x1B,0x48,0x63,0x03,0xB9,0x00,0x1C,0x80);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0x50,0x30,0x00,0xE0,0xE1,0x01,0x00,0x28,0x0E,0x06,0x43,0x55,0x55,0x55,0x55,0x55);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xC0,0x95,0x88,0x88,0x88,0x88,0x88,0xC8,0x08,0x86,0xC6,0xE3,0x81,0x00,0x20,0x00,0x21);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xD0,0x42,0x88,0x00,0x00,0x00,0x00,0x40,0x00,0x00,0x31,0x04,0x41,0x06,0x00,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xE0,0x00,0x92,0x04,0x00,0x92,0x04,0x00,0x00,0x00,0x00,0x92,0x04,0x00,0x85,0x11,0x0C);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,16,0xF0,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x5E,0x4A,0x01,0x78,0x00,0x08,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x12);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x00,0x00,0x00,0x00,0x02,0x03,0x00,0x00,0x00,0x00,0x02,0x03,0x01,0x41,0x37);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0xF1,0xE7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2D,0x23,0x05);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,8,0xA0,0xFB,0x08,0x2D,0x23,0x05,0xFB,0x0C);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x13);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xFD,0x0F,0x00,0x0C,0x00,0x00,0x00,0x00,0x01,0x08,0x01,0x1C,0x44,0x0C,0xCE,0xE7);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,15,0x90,0x62,0x0E,0x24,0x98,0xAC,0x21,0x01,0x00,0xD0,0x93,0x24,0x49,0x06,0x20);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x14);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x01,0x02,0x41,0x36,0xE9,0xEF,0xF7,0xFB,0xFD,0x7E,0x01,0x00,0x00,0x90,0xC5,0x8A);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x27,0x6D,0x20,0x4E,0x3C,0x69,0x03,0xDB,0xE0,0x49,0x1B,0xD8,0x08,0x4F,0xDA,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x82,0xB5,0xE2,0xF7,0x47,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0xD8,0x89,0xDF,0x1F,0x01,0x00,0x00,0x00,0x00,0x1C,0xB2,0x21,0x2B,0x00,0x40,0xA1);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xC0,0x50,0x78,0x17,0xDA,0xF4,0x80,0x51,0x1C,0x6F,0x42,0x9B,0x1E,0x30,0x8A,0xE3,0x3D);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xD0,0x68,0xD3,0x03,0x46,0x71,0xBC,0x05,0x6D,0x7A,0xC0,0x28,0x8E,0x77,0xA0,0x4D,0x0F);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xE0,0x18,0xC5,0xF1,0x06,0xB4,0xE9,0x01,0xA3,0x38,0x5E,0x80,0x36,0x3D,0x60,0x14,0xC7);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xF0,0x2B,0xD0,0xA6,0x07,0x8C,0xE2,0x18,0x01,0xBF,0xDF,0x08,0x00,0x00,0x00,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x15);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xD9,0xE0,0xF7);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0xA3,0x00,0x20,0x4B,0x07,0xAB,0xC5,0x03,0x00,0x00,0xD6,0xC1,0x6A,0xF1,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x90);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0x75,0xA1,0x6A,0xB5,0x00,0x00,0x00,0x00,0x13,0x00,0xF0,0x00,0x14,0xD3,0x34,0xCD);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xC0,0x90,0x02,0x4D,0x10,0x20,0x10,0x06,0x6A,0xDB,0xB6,0x6D,0xDB,0xB6,0x35,0x4D,0xD3);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xD0,0x34,0x21,0x13,0x04,0x01,0x02,0x61,0xA8,0xB6,0x6D,0xDB,0xB6,0x6D,0xDB,0xB6,0x35);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xE0,0xCD,0xD0,0x02,0x4D,0x50,0x30,0x14,0x47,0x6A,0xDB,0xB6,0x6D,0xDB,0xB6,0x6D,0x5B);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xF0,0xD3,0x34,0x25,0x13,0x04,0x05,0x43,0x71,0xAC,0xB6,0x6D,0xDB,0xB6,0x6D,0x5B,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x16);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x02,0x42,0x41,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,7,0x90,0x00,0x00,0x00,0x00,0xF0,0x20);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x18);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xEF,0xBD,0xF7,0xDE,0x7B,0xEF,0xBD,0x07,0x08,0x08,0x0A,0x0C,0x0C,0x0C,0x0C,0x0C);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x0C,0x0C,0x0C,0x5C,0x09,0xA8,0xAA,0xAA,0xAA,0xAA,0xAA,0xAA,0xAA,0xAA,0xAA,0x5A);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x09,0x04,0xFF,0x00,0x80);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,16,0xB0,0x80,0x00,0x04,0x20,0x00,0x01,0x08,0x40,0x00,0x02,0x10,0x80,0x00,0x04,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x19);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xC0,0xAF,0xA3,0x9B,0x92,0x8D,0x8A,0x86,0x84,0x83,0x82,0x81,0x00,0x50,0xF6,0xCF);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0xFC,0x2F,0xF3,0xEF,0xCF,0xBF,0x0F,0xFF,0xAF,0xB5,0x71,0x0E,0x6C,0x4A,0x69,0x08);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,5,0xA0,0x00,0x00,0x08,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x1A);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x04,0x08,0x0C,0x00,0x10,0x14,0x18,0x1C,0x00,0x20,0x28,0x30,0x38,0x00,0x40);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xA0,0xA8);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0xB0,0xB8,0x00,0xC0,0xC8,0xD0,0xD8,0x00,0xE0,0xE8,0xF0,0xF8,0x00,0xFC,0xFE,0xFF);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0x00,0x00,0x04,0x08,0x0C,0x00,0x10,0x14,0x18,0x1C,0x00,0x20,0x28,0x30,0x38,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xC0,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xA0);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xD0,0xA8,0xB0,0xB8,0x00,0xC0,0xC8,0xD0,0xD8,0x00,0xE0,0xE8,0xF0,0xF8,0x00,0xFC,0xFE);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xE0,0xFF,0x00,0x00,0x04,0x08,0x0C,0x00,0x10,0x14,0x18,0x1C,0x00,0x20,0x28,0x30,0x38);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xF0,0x00,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x1B);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xA0,0xA8,0xB0,0xB8,0x00,0xC0,0xC8,0xD0,0xD8,0x00,0xE0,0xE8,0xF0,0xF8,0x00,0xFC);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,5,0x90,0xFE,0xFF,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x20);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,8,0x80,0x81,0x00,0x00,0x00,0x00,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x22);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,14,0x80,0x2D,0xD3,0x00,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x9F,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x23);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x01,0x05,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,13,0x90,0xFF,0x0F,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0xFF,0x07,0x35);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x24);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x03,0x00,0xFF,0xFF,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFC,0x30);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x5A,0x5A,0x5A,0x55,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
	// BIST MODE
//	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x02,0x5A);
	//SPI FINISH
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x42,0x24);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x90,0x00);
	//Blank select 2F 
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x2F);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x19,0x00);
//	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x4C,0x03);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,1,0x11);
	delayMs(120);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,1,0x29);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x51,0xFF,0x0F);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x53,0x24);
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x55,0x00);
	delayMs(10);
#endif
#ifdef FT8006S_HKC6517_4L_720x1600_gamma22
	
	delayMs(10);
//	delayMs(1000);
#if  1
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x41,0x5A);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x24);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x90,0x5A);
	
	//VCOM
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x03);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x80, 0x3f, 0x01);

	//----------------------LCD initial code start----------------------//
	//Blank 8
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x08);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 4, 0x80, 0x3f, 0x2d, 0x05);
	//Blank 9
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x09);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x5A, 0x51, 0xB5, 0x2A, 0x6C, 0xC5, 0x4A, 0x01, 0x40, 0x62, 0x0F, 0x82, 0x20, 0x08, 0xF0, 0xB7);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0x00, 0x24, 0x42, 0x0A, 0xE3, 0x91, 0xA4, 0xF0, 0xC3, 0xE1, 0x6B, 0x20, 0x69, 0xA1, 0x26, 0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xA0, 0x51, 0x55, 0x55, 0x0A/*0x00*/, 0xA0, 0x4C, 0x06, 0x11, 0x0D, 0x60, 0x00, 0xFF, 0xFF, 0x03, 0xA5, 0xE6);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xB0, 0x08, 0x3A, 0x12, 0x64, 0x0B, 0x00, 0x00, 0x11, 0x00, 0x60, 0x00, 0xFF, 0xFF, 0x03, 0xFF, 0x34);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 6, 0xC0, 0x0C, 0xFF, 0x18, 0x9F, 0x0F, 0x00, 0x08, 0x00);
	//Blank 10	gamma2.2
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x0A);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0xFF, 0x51, 0xA3, 0x02, 0x00, 0x1E, 0x2E, 0x3F, 0x50, 0x60, 0x65, 0x94, 0x75, 0xAC, 0x8B, 0x58);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0x87, 0x5D, 0x58, 0x48, 0x37, 0x25, 0x16, 0x0B, 0x00, 0x1E, 0x2E, 0x3F, 0x50, 0x60, 0x65, 0x94);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 14, 0xA0, 0x75, 0xAC, 0x8B, 0x58, 0x87, 0x5D, 0x58, 0x48, 0x37, 0x25, 0x16, 0x0B, 0x00);
	//Blank 11
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x0B);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x00, 0x00, 0x20, 0x44, 0x08, 0x00, 0x60, 0x47, 0x00, 0x00, 0x10, 0x22, 0x04, 0x00, 0xB0, 0x23);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x90, 0x15, 0x00);
	//Blank 12
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x0C);
	//hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0xFA, 0x68, 0x68, 0x81, 0xAF, 0x8D, 0x30, 0x07, 0x00, 0x60, 0x15, 0x00, 0x50, 0x15, 0x56, 0x51);
//	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xBA,0x68,0x68,0x01,0x32,0x4B,0x58,0x07,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0xFA, 0x68, 0x68, 0x81, 0xB8, 0x8D, 0x30, 0x07, 0x00, 0x60, 0x15, 0x00, 0x50, 0x15, 0x56, 0x51);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0x15, 0x55, 0x61, 0x15, 0x00, 0x60, 0x15, 0x00, 0x50, 0x15, 0x56, 0x51, 0x15, 0x55, 0x61, 0x95);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xA0, 0xAB, 0x18, 0x00, 0x05, 0x00, 0x05, 0x00, 0x05, 0x80, 0x4C, 0x29, 0x84, 0x52, 0x01, 0x09, 0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0xB0, 0x00, 0x00);
	//Blank 13
	/*hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x0D);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 8, 0x80, 0xF0, 0xB1, 0x71, 0xEF, 0x4B, 0xC0, 0x80);
	//Blank 14
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x0E);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 9, 0x80, 0xFF, 0x01, 0x55, 0x55, 0x32, 0x88, 0x88, 0x1C);*/
	//Blank 15
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x0F);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0xB5, 0x05, 0x82, 0xC0, 0x10, 0xA0, 0x63, 0x08, 0x52, 0x51, 0x58, 0x49, 0x03, 0x52, 0x4C, 0x4C);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0x68, 0x68, 0x68, 0x4C, 0x4C, 0x7C, 0x14, 0x00, 0x20, 0x06, 0xC2, 0x00, 0x04, 0x06, 0x0C, 0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 5, 0xA0, 0x00, 0x92, 0x00, 0x00);
	//Blank 16
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x10);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x00, 0x00, 0x03, 0xE7, 0x1F, 0x17, 0x00, 0x48, 0x40, 0x02, 0xCF, 0x18, 0x30, 0x88, 0x41, 0x8A);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 16, 0x90, 0x39, 0x28, 0xA9, 0xC5, 0x9A, 0x7B, 0xF0, 0x07, 0x7E, 0xE0, 0x07, 0x7E, 0x20, 0x10, 0x00);
	//Blank 17
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x11);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x46, 0x77, 0x03, 0x40, 0xCA, 0xF3, 0xFF, 0x83, 0x30, 0x08, 0xC4, 0x06, 0xA1, 0xD8, 0x24, 0x18);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0x30, 0xC6, 0x66, 0xC1, 0x80, 0x31, 0x15, 0xCB, 0xE5, 0xD2, 0x68, 0x6C, 0x36, 0x1D, 0x04, 0xC8);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xA0, 0xB0, 0xD9, 0x88, 0x60, 0xB0, 0x81, 0x40, 0x1A, 0x1B, 0x48, 0x63, 0x03, 0xB9, 0x00, 0x1C, 0x80);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xB0, 0x50, 0x30, 0x00, 0xE0, 0xE1, 0x01, 0x00, 0x28, 0x0E, 0x06, 0x43, 0x55, 0x55, 0x55, 0x55, 0x55);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xC0, 0x95, 0x88, 0x88, 0x88, 0x88, 0x88, 0xC8, 0x08, 0x86, 0xC6, 0xE3, 0x81, 0x00, 0x20, 0x00, 0x21);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xD0, 0x42, 0x88, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x31, 0x04, 0x41, 0x06, 0x00, 0x00, 0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xE0, 0x00, 0x92, 0x04, 0x00, 0x92, 0x04, 0x00, 0x00, 0x00, 0x00, 0x92, 0x04, 0x00, 0x85, 0x11, 0x0C);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 16, 0xF0, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x5E, 0x4A, 0x01, 0x78, 0x00, 0x08, 0x00, 0x00);
	//Blank 18
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x12);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x03, 0x00, 0x00, 0x00, 0x00, 0x02, 0x03, 0x01, 0x41, 0x37);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0xF1, 0xE7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2D, 0x23, 0x05);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 8, 0xA0, 0xFB, 0x08, 0x2D, 0x23, 0x05, 0xFB, 0x0C);
	//Blank 19
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x13);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0xFD, 0x0F, 0x00, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x01, 0x08, 0x01, 0x1C, 0x44, 0x0C, 0xCE, 0xE7);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 15, 0x90, 0x62, 0x0E, 0x24, 0x98, 0xAC, 0x21, 0xB1, 0x88, 0xD0, 0x93, 0x24, 0x49, 0x06, 0x20);
	//Blank 20
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x14);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x01, 0x02, 0x41, 0x36, 0xE9, 0xEF, 0xF7, 0xFB, 0xFD, 0x7E, 0x01, 0x00, 0x00, 0x7C, 0xC5, 0x85);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0x26, 0x3D, 0x20, 0x26, 0x34, 0xE9, 0x01, 0xF1, 0xA0, 0x49, 0x0F, 0x88, 0x05, 0x4D, 0x7A, 0xC0);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xA0, 0x02, 0x68, 0xD2, 0x03, 0x96, 0x40, 0x93, 0x1E, 0x00, 0xF8, 0x82, 0xB5, 0xE2, 0xF7, 0x47, 0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xB0, 0xD8, 0x89, 0xDF, 0x1F, 0x01, 0x00, 0x10, 0x00, 0x00, 0xBC, 0xAF, 0xFB, 0x2A, 0x00, 0x40, 0xA1);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xC0, 0x50, 0x78, 0x07, 0x1A, 0xFC, 0x80, 0x52, 0x1C, 0x6F, 0x40, 0x83, 0x1F, 0x50, 0x8A, 0xE3, 0x05);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xD0, 0x68, 0xF0, 0x03, 0x4A, 0x71, 0xBC, 0x02, 0x0D, 0x7E, 0x40, 0x29, 0x8E, 0x97, 0xA0, 0xC1, 0x0F);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xE0, 0x28, 0xC5, 0xF1, 0x1A, 0x34, 0xF8, 0x01, 0xA5, 0x38, 0x5E, 0x84, 0x06, 0x3F, 0xA0, 0x14, 0xC7);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xF0, 0xAB, 0xD0, 0xE0, 0x07, 0x94, 0xE2, 0x18, 0x01, 0xBF, 0xDF, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00);
	//Blank 21
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x15);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0xD8, 0xE0, 0xF7);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0xA3, 0x80, 0xFB, 0x5A, 0x84, 0xCA, 0xE3, 0x05, 0xE1, 0xF1, 0x12, 0xA1, 0xF2, 0x78, 0x41, 0x78);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xA0, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xB0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x13, 0x00, 0xF0, 0x00, 0x94, 0x15, 0x5B, 0x57);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xC0, 0x90, 0x82, 0xD4, 0x10, 0x20, 0x10, 0x66, 0x5D, 0xDB, 0xB6, 0x6D, 0xDB, 0xB6, 0x55, 0xA5, 0x75);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xD0, 0x5D, 0xD7, 0x55, 0x10, 0x0C, 0x43, 0x51, 0x1C, 0xC7, 0x6A, 0xDB, 0xB6, 0x6D, 0xDB, 0x55, 0x5B);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xE0, 0x57, 0xD0, 0x92, 0xD4, 0x50, 0x30, 0x14, 0x67, 0x5D, 0xDB, 0xB6, 0x6D, 0xDB, 0xB6, 0x55, 0xA1);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xF0, 0x75, 0x5D, 0xD7, 0x15, 0x00, 0x08, 0x02, 0x41, 0x18, 0x86, 0x6A, 0xDB, 0xB6, 0x6D, 0x5B, 0xC0);
	//Blank 22
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x16);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0xC3, 0x43, 0x41, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 7, 0x90, 0x00, 0x00, 0x00, 0x00, 0xF0, 0x20);
	//Blank 24
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x18);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0xEF, 0xBD, 0xF7, 0xDE, 0x7B, 0xEF, 0xBD, 0x07, 0x08, 0x08, 0x0A, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0x0C, 0x0C, 0x0C, 0x5C, 0x09, 0xA8, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0x5A);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xA0, 0x59, 0x59, 0x59, 0x59, 0x59, 0x59, 0x59, 0x59, 0x59, 0x59, 0x59, 0x09, 0x04, 0xFF, 0x00, 0x80);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 16, 0xB0, 0x80, 0x00, 0x04, 0x20, 0x00, 0x01, 0x08, 0x40, 0x00, 0x02, 0x10, 0x80, 0x00, 0x04, 0x00);
	//Blank 25
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x19);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0xC0, 0xAF, 0xA3, 0x9B, 0x92, 0x8D, 0x8A, 0x86, 0x84, 0x83, 0x82, 0x81, 0x00, 0x50, 0xF6, 0xCF);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0xFC, 0x2F, 0xF3, 0xEF, 0xCF, 0xBF, 0x0F, 0xFF, 0xAF, 0xB5, 0x71, 0x0E, 0x6C, 0x4A, 0x69, 0x08);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 5, 0xA0, 0x00, 0x00, 0x08, 0x00);
	//Blank 26
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 5, 0x41, 0x5A, 0x1A);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x00, 0x04, 0x08, 0x0C, 0x00, 0x10, 0x14, 0x18, 0x1C, 0x00, 0x20, 0x28, 0x30, 0x38, 0x00, 0x40);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0x48, 0x50, 0x58, 0x00, 0x60, 0x68, 0x70, 0x78, 0x00, 0x80, 0x88, 0x90, 0x98, 0x00, 0xA0, 0xA8);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xA0, 0xB0, 0xB8, 0x00, 0xC0, 0xC8, 0xD0, 0xD8, 0x00, 0xE0, 0xE8, 0xF0, 0xF8, 0x00, 0xFC, 0xFE, 0xFF);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xB0, 0x00, 0x00, 0x04, 0x08, 0x0C, 0x00, 0x10, 0x14, 0x18, 0x1C, 0x00, 0x20, 0x28, 0x30, 0x38, 0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xC0, 0x40, 0x48, 0x50, 0x58, 0x00, 0x60, 0x68, 0x70, 0x78, 0x00, 0x80, 0x88, 0x90, 0x98, 0x00, 0xA0);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xD0, 0xA8, 0xB0, 0xB8, 0x00, 0xC0, 0xC8, 0xD0, 0xD8, 0x00, 0xE0, 0xE8, 0xF0, 0xF8, 0x00, 0xFC, 0xFE);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xE0, 0xFF, 0x00, 0x00, 0x04, 0x08, 0x0C, 0x00, 0x10, 0x14, 0x18, 0x1C, 0x00, 0x20, 0x28, 0x30, 0x38);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0xF0, 0x00, 0x40, 0x48, 0x50, 0x58, 0x00, 0x60, 0x68, 0x70, 0x78, 0x00, 0x80, 0x88, 0x90, 0x98, 0x00);
	//Blank 27
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x1B);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0xA0, 0xA8, 0xB0, 0xB8, 0x00, 0xC0, 0xC8, 0xD0, 0xD8, 0x00, 0xE0, 0xE8, 0xF0, 0xF8, 0x00, 0xFC);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 5, 0x90, 0xFE, 0xFF, 0x00, 0x00);
	//Blank 32
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x20);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 8, 0x80, 0x74, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);
	//Blank 34
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x22);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 14, 0x80, 0x2D, 0xD3, 0x00, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x9F, 0x00);
	//Blank 35
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x23);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x01, 0x05, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 13, 0x90, 0xFF, 0x0F, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0xFF, 0x07, 0x35);
	//Blank 36
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x24);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x80, 0x00, 0x03, 0x00, 0xFF, 0xFF, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0D, 0x0A);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 17, 0x90, 0x5A, 0x5A, 0x5A, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);

	// BIST MODE
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x02,0x5A);
	
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x42,0x24);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x90,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x2F);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x19,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x4C,0x03);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,1,0x11);
	delayMs(120);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,1,0x29);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x51,0xFF,0x0F);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x53,0x24);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x55,0x00);
	delayMs(10);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0xB7,0x59,0x02);
//	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x00,0xff,0x00);
#else
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x41,0x5A);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x24);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x90,0x5A);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x03);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x80,0x1A,0x01);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x08);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,4,0x80,0x1A,0x2D,0x05);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x09);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x5A,0x51,0xB5,0x2A,0x6C,0xE5,0x4A,0x01,0x40,0x62,0x0F,0x82,0x20,0x08,0xF0,0xB7);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x00,0x24,0x42,0x0A,0xE3,0x91,0xA4,0xF0,0xD6,0xC3,0x70,0x20,0x2D,0xA1,0x26,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0x51,0x55,0x55,0x00,0xA0,0x4D,0x06,0x11,0x0D,0x60,0x00,0xFF,0xFF,0x03,0xA5,0xE6);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0x08,0x3A,0x12,0x64,0x0B,0x00,0x00,0x11,0x00,0x60,0x00,0xFF,0xFF,0x03,0xFF,0x34);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,9,0xC0,0x0C,0xFF,0x18,0x9F,0x0F,0x00,0x08,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0A);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xFF,0xB6,0x6D,0x03,0x00,0x10,0x1D,0x2E,0x40,0x52,0x59,0x8E,0x70,0xAE,0x86,0x4D);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x81,0x54,0x50,0x40,0x31,0x21,0x14,0x0B,0x00,0x10,0x1D,0x2E,0x40,0x52,0x59,0x8E);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,14,0xA0,0x70,0xAE,0x86,0x4D,0x81,0x54,0x50,0x40,0x31,0x21,0x14,0x0B,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0B);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x00,0x20,0x44,0x08,0x00,0x60,0x47,0x00,0x00,0x10,0x22,0x04,0x00,0xB0,0x23);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x90,0x15,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0C);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xBA,0x68,0x68,0x01,0x32,0x4B,0x58,0x07,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x15,0x55,0x61,0x15,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51,0x15,0x55,0x61,0x95);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0xAB,0x18,0x00,0x05,0x00,0x05,0x00,0x05,0x00,0x49,0x29,0x84,0x52,0x01,0x09,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0xB0,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0D);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,8,0x80,0xF0,0xB1,0x71,0xEF,0x4B,0xC0,0x80);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0E);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,9,0x80,0xFF,0x01,0x55,0x55,0x23,0x88,0x88,0x1C);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x0F);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xBD,0x07,0x70,0xC0,0x12,0x08,0x64,0x08,0x52,0x51,0x58,0x49,0x03,0x52,0x4C,0x4C);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x68,0x68,0x68,0x4C,0x4C,0x7C,0x14,0x00,0x20,0x06,0xC2,0x00,0x04,0x06,0x0C,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,5,0xA0,0x00,0x92,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x10);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x00,0x03,0xE7,0x1F,0x17,0x10,0x48,0x80,0xAA,0xD0,0x18,0x30,0x88,0x41,0x8A);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,16,0x90,0x39,0x28,0xA9,0xC5,0x9A,0x7B,0xF0,0x07,0x7E,0xE0,0x07,0x7E,0x20,0x10,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x11);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x46,0x77,0x03,0x40,0xCA,0xF3,0xFF,0x83,0x30,0x08,0xC4,0x06,0xA1,0xD8,0x24,0x18);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x30,0xC6,0x66,0xC1,0x80,0x31,0x15,0xCB,0xE5,0xD2,0x68,0x6C,0x36,0x1D,0x04,0xC8);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0xB0,0xD9,0x88,0x60,0xB0,0x81,0x40,0x1A,0x1B,0x48,0x63,0x03,0xB9,0x00,0x1C,0x80);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0x50,0x30,0x00,0xE0,0xE1,0x01,0x00,0x28,0x0E,0x06,0x43,0x55,0x55,0x55,0x55,0x55);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xC0,0x95,0x88,0x88,0x88,0x88,0x88,0xC8,0x08,0x86,0xC6,0xE3,0x81,0x00,0x20,0x00,0x21);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xD0,0x42,0x88,0x00,0x00,0x00,0x00,0x40,0x00,0x00,0x31,0x04,0x41,0x06,0x00,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xE0,0x00,0x92,0x04,0x00,0x92,0x04,0x00,0x00,0x00,0x00,0x92,0x04,0x00,0x85,0x11,0x0C);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,16,0xF0,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x5E,0x4A,0x01,0x78,0x00,0x08,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x12);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x00,0x00,0x00,0x00,0x02,0x03,0x00,0x00,0x00,0x00,0x02,0x03,0x01,0x41,0x37);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0xF1,0xE7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2D,0x23,0x05);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,8,0xA0,0xFB,0x08,0x2D,0x23,0x05,0xFB,0x0C);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x13);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xFD,0x0F,0x00,0x0C,0x00,0x00,0x00,0x00,0x01,0x08,0x01,0x1C,0x44,0x0C,0xCE,0xE7);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,15,0x90,0x62,0x0E,0x24,0x98,0xAC,0x21,0x01,0x00,0xD0,0x93,0x24,0x49,0x06,0x20);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x14);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x01,0x02,0x41,0x36,0xE9,0xEF,0xF7,0xFB,0xFD,0x7E,0x01,0x00,0x00,0x90,0xC5,0x8A);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x27,0x6D,0x20,0x4E,0x3C,0x69,0x03,0xDB,0xE0,0x49,0x1B,0xD8,0x08,0x4F,0xDA,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x82,0xB5,0xE2,0xF7,0x47,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0xD8,0x89,0xDF,0x1F,0x01,0x00,0x00,0x00,0x00,0x1C,0xB2,0x21,0x2B,0x00,0x40,0xA1);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xC0,0x50,0x78,0x17,0xDA,0xF4,0x80,0x51,0x1C,0x6F,0x42,0x9B,0x1E,0x30,0x8A,0xE3,0x3D);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xD0,0x68,0xD3,0x03,0x46,0x71,0xBC,0x05,0x6D,0x7A,0xC0,0x28,0x8E,0x77,0xA0,0x4D,0x0F);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xE0,0x18,0xC5,0xF1,0x06,0xB4,0xE9,0x01,0xA3,0x38,0x5E,0x80,0x36,0x3D,0x60,0x14,0xC7);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xF0,0x2B,0xD0,0xA6,0x07,0x8C,0xE2,0x18,0x01,0xBF,0xDF,0x08,0x00,0x00,0x00,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x15);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xD9,0xE0,0xF7);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0xA3,0x00,0x20,0x4B,0x07,0xAB,0xC5,0x03,0x00,0x00,0xD6,0xC1,0x6A,0xF1,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x90);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0x75,0xA1,0x6A,0xB5,0x00,0x00,0x00,0x00,0x13,0x00,0xF0,0x00,0x14,0xD3,0x34,0xCD);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xC0,0x90,0x02,0x4D,0x10,0x20,0x10,0x06,0x6A,0xDB,0xB6,0x6D,0xDB,0xB6,0x35,0x4D,0xD3);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xD0,0x34,0x21,0x13,0x04,0x01,0x02,0x61,0xA8,0xB6,0x6D,0xDB,0xB6,0x6D,0xDB,0xB6,0x35);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xE0,0xCD,0xD0,0x02,0x4D,0x50,0x30,0x14,0x47,0x6A,0xDB,0xB6,0x6D,0xDB,0xB6,0x6D,0x5B);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xF0,0xD3,0x34,0x25,0x13,0x04,0x05,0x43,0x71,0xAC,0xB6,0x6D,0xDB,0xB6,0x6D,0x5B,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x16);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x02,0x42,0x41,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,7,0x90,0x00,0x00,0x00,0x00,0xF0,0x20);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x18);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xEF,0xBD,0xF7,0xDE,0x7B,0xEF,0xBD,0x07,0x08,0x08,0x0A,0x0C,0x0C,0x0C,0x0C,0x0C);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x0C,0x0C,0x0C,0x5C,0x09,0xA8,0xAA,0xAA,0xAA,0xAA,0xAA,0xAA,0xAA,0xAA,0xAA,0x5A);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x09,0x04,0xFF,0x00,0x80);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,16,0xB0,0x80,0x00,0x04,0x20,0x00,0x01,0x08,0x40,0x00,0x02,0x10,0x80,0x00,0x04,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x19);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xC0,0xAF,0xA3,0x9B,0x92,0x8D,0x8A,0x86,0x84,0x83,0x82,0x81,0x00,0x50,0xF6,0xCF);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0xFC,0x2F,0xF3,0xEF,0xCF,0xBF,0x0F,0xFF,0xAF,0xB5,0x71,0x0E,0x6C,0x4A,0x69,0x08);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,5,0xA0,0x00,0x00,0x08,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x1A);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x04,0x08,0x0C,0x00,0x10,0x14,0x18,0x1C,0x00,0x20,0x28,0x30,0x38,0x00,0x40);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xA0,0xA8);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xA0,0xB0,0xB8,0x00,0xC0,0xC8,0xD0,0xD8,0x00,0xE0,0xE8,0xF0,0xF8,0x00,0xFC,0xFE,0xFF);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xB0,0x00,0x00,0x04,0x08,0x0C,0x00,0x10,0x14,0x18,0x1C,0x00,0x20,0x28,0x30,0x38,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xC0,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xA0);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xD0,0xA8,0xB0,0xB8,0x00,0xC0,0xC8,0xD0,0xD8,0x00,0xE0,0xE8,0xF0,0xF8,0x00,0xFC,0xFE);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xE0,0xFF,0x00,0x00,0x04,0x08,0x0C,0x00,0x10,0x14,0x18,0x1C,0x00,0x20,0x28,0x30,0x38);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0xF0,0x00,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x1B);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0xA0,0xA8,0xB0,0xB8,0x00,0xC0,0xC8,0xD0,0xD8,0x00,0xE0,0xE8,0xF0,0xF8,0x00,0xFC);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,5,0x90,0xFE,0xFF,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x20);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,8,0x80,0x81,0x00,0x00,0x00,0x00,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x22);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,14,0x80,0x2D,0xD3,0x00,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x9F,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x23);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x01,0x05,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,13,0x90,0xFF,0x0F,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0xFF,0x07,0x35);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x24);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x80,0x00,0x03,0x00,0xFF,0xFF,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFC,0x30);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,17,0x90,0x5A,0x5A,0x5A,0x55,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);

	// BIST MODE
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x02,0x5A);
	
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x42,0x24);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x90,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x41,0x5A,0x2F);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x19,0x00);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x4C,0x03);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,1,0x11);
	delayMs(120);
//	hal_dsi_tx_ctrl_write_cmd(0x39,0,1,0x29);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x51,0xFF,0x0F);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x53,0x24);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x55,0x00);
	delayMs(10);
	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0xB7,0x59,0x02);
//	hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x00,0xff,0x00);
#endif

#endif	
//	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,1,0xB7);
//	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,1,0x59);
//	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,1,0x02);
//	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,3,0x00,0xff,0x00);
#if 1
#if  0
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x41,0x5a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x24);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x90,0x5a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x03);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x80,0x25,0x01);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x08);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x04,0x80,0x20,0x2d,0x05);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x09);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x5a,0x51,0xb5,0x2a,0x6c,0xe5,0x4a,0x01,0x40,0x62,0x0f,0x82,0x20,0x08,0xf0,0xb7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0x00,0x24,0x42,0x0a,0xe3,0x91,0xa4,0xf0,0xc3,0xc3,0x6b,0x20,0x2d,0xa1,0x26,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xa0,0x51,0x55,0x55,0x00,0xa0,0x4c,0x06,0x11,0x0d,0x60,0x5a,0xff,0xff,0x03,0xa5,0xe6);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xb0,0x08,0xc9,0x16,0x64,0x0b,0x00,0x00,0x11,0x07,0x60,0x00,0xff,0xff,0x03,0xff,0x34);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x09,0xc0,0x0c,0x3f,0x1f,0x9f,0x0f,0x00,0x08,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x0a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0xff,0xb6,0x6d,0x03,0x00,0x0f,0x1b,0x2b,0x3d,0x4e,0x55,0x89,0x68,0xa5,0x8e,0x56);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0x85,0x58,0x53,0x43,0x33,0x23,0x16,0x0b,0x00,0x0f,0x1b,0x2b,0x3d,0x4e,0x55,0x89);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x0e,0xa0,0x68,0xa5,0x8e,0x56,0x85,0x58,0x53,0x43,0x33,0x23,0x16,0x0b,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x0b);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x00,0x00,0x20,0x44,0x08,0x00,0x60,0x47,0x00,0x00,0x10,0x22,0x04,0x00,0xb0,0x23);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x90,0x15,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0xfa,0x68,0x68,0x01,0xb2,0x75,0xd0,0x07,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0x15,0x55,0x61,0x15,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51,0x15,0x55,0x61,0x95);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xa0,0xab,0x18,0x00,0x05,0x00,0x05,0x00,0x05,0x80,0x4c,0x29,0x84,0x52,0x01,0x09,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0xb0,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x0d);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x08,0x80,0xf0,0xb1,0x71,0xef,0x4b,0xc0,0x80);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x0e);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x09,0x80,0xff,0x01,0x55,0x55,0x23,0x88,0x88,0x1c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x0f);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0xd1,0x07,0x70,0x40,0x13,0x38,0x64,0x08,0x52,0x51,0x58,0x49,0x03,0x52,0x4c,0x4c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0x68,0x68,0x68,0x4c,0x4c,0x7c,0x14,0x00,0x20,0x06,0xc2,0x00,0x04,0x06,0x0c,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x05,0xa0,0x00,0x92,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x10);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x00,0x00,0x03,0xe7,0x1f,0x17,0x10,0x48,0x80,0xaa,0xd0,0x18,0x30,0x88,0x41,0x8a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x10,0x90,0x39,0x28,0xa9,0xc5,0x9a,0x7b,0xf0,0x07,0x7e,0xe0,0x07,0x7e,0x20,0x10,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x11);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x49,0x77,0x03,0x40,0xca,0xf3,0xff,0xa3,0x20,0x08,0xc4,0x06,0xa1,0xd8,0x24,0x18);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0x30,0xc6,0x66,0xc1,0x80,0x1d,0x15,0xcb,0xe5,0xe2,0x70,0x6c,0x36,0x1d,0x04,0xc8);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xa0,0xb0,0xd9,0x88,0x60,0xb0,0x81,0x40,0x1c,0x1b,0x88,0x63,0x03,0xb9,0x00,0x1c,0x80);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xb0,0x50,0x30,0x00,0xe0,0xe1,0x01,0x00,0x28,0x0e,0x06,0x43,0x55,0x55,0x55,0x55,0x55);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xc0,0x95,0x88,0x88,0x88,0x88,0x88,0xc8,0x08,0x84,0xc6,0xe3,0x81,0x00,0x20,0x00,0x21);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xd0,0x42,0x88,0x00,0x00,0x00,0x00,0x40,0x00,0x20,0x31,0x04,0x41,0x06,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xe0,0x00,0x92,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x92,0x04,0x00,0x85,0x11,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x10,0xf0,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x5e,0x4a,0x01,0x10,0x22,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x12);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x00,0x00,0x00,0x00,0x00,0x02,0x03,0x00,0x00,0x00,0x00,0x02,0x03,0x01,0x41,0x37);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0xf1,0xe7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2d,0x23,0x05);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x08,0xa0,0xfb,0x08,0x2d,0x23,0x05,0xfb,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x13);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0xfd,0x0f,0x00,0x0c,0x00,0x00,0x00,0x00,0x01,0x08,0x01,0x1c,0x44,0x0c,0xce,0xe7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x0f,0x90,0x62,0x0e,0x24,0x98,0xac,0x21,0x01,0x00,0xd0,0x93,0x24,0x49,0x06,0x20);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x14);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x01,0x02,0x41,0x36,0xe9,0xef,0xf7,0xfb,0xfd,0x7e,0x00,0x00,0x00,0x90,0xc5,0x89);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0x27,0x3d,0x20,0x46,0x3c,0xe9,0x01,0xf1,0xe1,0x49,0x0f,0x88,0x0d,0x4f,0x7a,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xa0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xb0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1c,0xb2,0x21,0x2b,0x00,0x40,0xa1);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xc0,0x50,0x78,0x03,0xf8,0xb9,0x94,0x51,0x1c,0x2f,0x00,0x3f,0x97,0x32,0x8a,0xe3,0x15);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xd0,0xe0,0xe7,0x52,0x46,0x71,0xbc,0x04,0xfc,0x5c,0xca,0x28,0x8e,0x37,0x81,0x9f,0x4b);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xe0,0x19,0xc5,0xf1,0x1e,0xf0,0x73,0x29,0xa3,0x38,0xde,0x02,0x7e,0x2e,0x65,0x14,0xc7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xf0,0x3b,0xc0,0xcf,0xa5,0x8c,0xe2,0x18,0x01,0xbf,0x5f,0x08,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x15);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xd9,0xe0,0xf7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0xa3,0x00,0x20,0xcb,0x85,0xaa,0xd5,0x06,0x91,0x91,0x77,0xa1,0x6a,0xb5,0x41,0x64);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xa0,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x90);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xb0,0x75,0xa1,0x6a,0xb5,0x00,0x00,0x00,0x00,0x12,0x00,0x00,0x00,0x94,0xd6,0x0c,0x4d);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xc0,0xc9,0x12,0x0c,0xc5,0x21,0xc1,0xb6,0x6d,0xdb,0xb6,0x6d,0xdb,0xb6,0x6d,0xc9,0xd0);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xd0,0xa4,0x20,0x06,0x21,0x00,0x13,0x6c,0xdb,0xb6,0x6d,0xdb,0xb6,0x6d,0xdb,0xd6,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xe0,0x4d,0x88,0x02,0x08,0x84,0x21,0xc1,0xb6,0x6d,0xdb,0xb6,0x6d,0xdb,0xb6,0x6d,0xc9);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xf0,0xd0,0xb4,0x24,0x47,0x31,0x04,0x13,0x6c,0xdb,0xb6,0x6d,0xdb,0xb6,0x6d,0x5b,0x12);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x16);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x03,0x03,0x04,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x07,0x90,0x00,0x00,0x00,0x00,0xf0,0x20);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x18);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0xef,0xbd,0xf7,0xde,0x7b,0xef,0xbd,0x07,0x08,0x08,0x0a,0x0c,0x0c,0x0c,0x0c,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0x0c,0x0c,0x0c,0x5c,0x09,0xa8,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0x5a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xa0,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x09,0x04,0xff,0x00,0x80);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x10,0xb0,0x80,0x00,0xcc,0x1a,0xda,0x00,0xc8,0xb6,0xd1,0x01,0xf0,0x4c,0x3e,0x01,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x19);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0xc0,0xaf,0xa3,0x9b,0x92,0x8d,0x8a,0x86,0x84,0x83,0x82,0x81,0x00,0x50,0xf6,0xcf);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0xfc,0x2f,0xf3,0xef,0xcf,0xbf,0x0f,0xff,0xaf,0xb5,0x71,0x0e,0x6c,0x4a,0x69,0x08);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x05,0xa0,0x06,0x06,0x02,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x1a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x00,0x04,0x08,0x0c,0x00,0x10,0x14,0x18,0x1c,0x00,0x20,0x28,0x30,0x38,0x00,0x40);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xa0,0xa8);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xa0,0xb0,0xb8,0x00,0xc0,0xc8,0xd0,0xd8,0x00,0xe0,0xe8,0xf0,0xf8,0x00,0xfc,0xfe,0xff);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xb0,0x00,0x00,0x04,0x08,0x0c,0x00,0x10,0x14,0x18,0x1c,0x00,0x20,0x28,0x30,0x38,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xc0,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xa0);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xd0,0xa8,0xb0,0xb8,0x00,0xc0,0xc8,0xd0,0xd8,0x00,0xe0,0xe8,0xf0,0xf8,0x00,0xfc,0xfe);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xe0,0xff,0x00,0x00,0x04,0x08,0x0c,0x00,0x10,0x14,0x18,0x1c,0x00,0x20,0x28,0x30,0x38);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0xf0,0x00,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x1b);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0xa0,0xa8,0xb0,0xb8,0x00,0xc0,0xc8,0xd0,0xd8,0x00,0xe0,0xe8,0xf0,0xf8,0x00,0xfc);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x05,0x90,0xfe,0xff,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x20);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x08,0x80,0x87,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x22);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x0e,0x80,0x2d,0xd3,0x00,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x9f,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x23);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x01,0x05,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x0d,0x90,0xff,0x0f,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0xef,0x07,0x35);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x24);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x80,0x00,0x03,0x00,0xff,0xff,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x41,0x84);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x11,0x90,0x5a,0x5a,0x5a,0x55,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
	// BIST MODE
	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x02,0x5A);
	
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x42,0x24);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x90,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0x41,0x5a,0x2f);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x19,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x4c,0x03);


	// Video Mode Enable
	delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0xB7,0x59,0x02);


				
				delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x11);
				
				hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
				delayMs(10);
				hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_HIGH);
		//		swire_init();
				delayMs(50);
				
		//		
				
				hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);
		//		delayMs(10);
			
				hal_dsi_tx_ctrl_write_cmd(0x29, 0, 3, 0x51, 0x0F, 0xFF);
					delayMs(1);
				/* 0x29 tx start ֮ */
#else
/*
	delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x41,0x5a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x4c,0x03);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x24);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x90,0x5a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x03);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x80,0x19,0x01);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x08);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x04,0x80,0x19,0x2d,0x05);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x09);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x5a,0x51,0xb5,0x2a,0x6c,0xe5,0x4a,0x01,0x40,0x62,0x0f,0x82,0x20,0x08,0xf0,0xb7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x00,0x24,0x42,0x0a,0xe3,0x91,0xa4,0xf0,0xc2,0xb9,0x6b,0x20,0x19,0xa1,0x26,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0x51,0x55,0x55,0x00,0xa0,0x4d,0x06,0x11,0x0d,0x60,0x5a,0xff,0xff,0x03,0xa5,0xe6);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0x08,0xc9,0x16,0x64,0x0b,0x00,0x00,0x11,0x07,0x60,0x00,0xff,0xff,0x03,0xff,0x34);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x09,0xc0,0x0c,0x3f,0x1f,0x9f,0x0f,0x00,0x08,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xff,0xb6,0x6d,0x03,0x00,0x14,0x23,0x36,0x49,0x5c,0x63,0x98,0x83,0xbe,0x76,0x41);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x7b,0x50,0x4d,0x3e,0x2e,0x1f,0x10,0x0b,0x00,0x14,0x23,0x36,0x49,0x5c,0x63,0x98);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x0e,0xa0,0x83,0xbe,0x76,0x41,0x7b,0x50,0x4d,0x3e,0x2e,0x1f,0x10,0x0b,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0b);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x00,0x20,0x44,0x08,0x00,0x60,0x47,0x00,0x00,0x10,0x22,0x04,0x00,0xb0,0x23);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x90,0x15,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xfa,0x68,0x68,0x01,0xb2,0x75,0xb0,0x04,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x15,0x55,0x61,0x15,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51,0x15,0x55,0x61,0x95);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0xab,0x18,0x00,0x05,0x00,0x05,0x00,0x05,0x80,0x4c,0x29,0x84,0x52,0x01,0x09,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0xb0,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0d);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x08,0x80,0xf0,0xb1,0x71,0xef,0x4b,0xc0,0x80);
//	delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x08,0x80,0xf3,0xb1,0x71,0xef,0x4b,0xc0,0x80);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0e);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x09,0x80,0xff,0x01,0x55,0x55,0x23,0x88,0x88,0x1c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0f);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x14,0x40,0x6f,0xc0,0x12,0x08,0x64,0x08,0x52,0x31,0x58,0x49,0x03,0x52,0x4c,0x4c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x68,0x68,0x68,0x4c,0x4c,0x7c,0x14,0x00,0x20,0x06,0xc2,0x00,0x04,0x06,0x0c,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x05,0xa0,0x00,0x92,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x10);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x00,0x03,0xe7,0x1f,0x17,0x10,0x48,0x80,0xaa,0xd0,0x18,0x30,0x88,0x41,0x8a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x10,0x90,0x39,0x28,0xa9,0xc5,0x9a,0x7b,0xf0,0x07,0x7e,0xe0,0x07,0x7e,0x20,0x10,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x11);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x49,0x77,0x03,0x40,0xca,0xf3,0xff,0x83,0x30,0x08,0xc4,0x06,0xa1,0xd8,0x24,0x18);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x30,0xc6,0x66,0xc1,0x80,0x31,0x15,0xcb,0xe5,0xd2,0x68,0x6c,0x36,0x1d,0x04,0xc8);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0xb0,0xd9,0x88,0x60,0xb0,0x81,0x40,0x1a,0x1b,0x48,0x63,0x03,0xb9,0x00,0x1c,0x80);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0x50,0x30,0x00,0xe0,0xe1,0x01,0x00,0x28,0x0e,0x06,0x43,0x55,0x55,0x55,0x55,0x55);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xc0,0x95,0x88,0x88,0x88,0x88,0x88,0xc8,0x08,0x86,0xc6,0xe3,0x81,0x00,0x20,0x00,0x21);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xd0,0x42,0x88,0x00,0x00,0x00,0x00,0x40,0x00,0x00,0x31,0x04,0x41,0x06,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xe0,0x00,0x92,0x04,0x00,0x92,0x04,0x00,0x00,0x00,0x00,0x92,0x04,0x00,0x85,0x11,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x10,0xf0,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x5e,0x4a,0x01,0x78,0x00,0x08,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x12);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x00,0x00,0x00,0x00,0x02,0x03,0x00,0x00,0x00,0x00,0x02,0x03,0x00,0x41,0x37);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0xf1,0xe7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2d,0x23,0x05);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x08,0xa0,0xfb,0x08,0x2d,0x23,0x05,0xfb,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x13);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xfd,0x0f,0x00,0x0c,0x00,0x00,0x00,0x00,0x01,0x08,0x01,0x1c,0x44,0x0c,0xce,0xe7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x0f,0x90,0x62,0x0e,0x24,0x98,0xac,0x21,0x01,0x00,0xd0,0xff,0xff,0xff,0x07,0x20);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x14);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x01,0x02,0x41,0x36,0xe1,0xef,0xf7,0xfb,0xfd,0x7e,0x01,0x00,0x00,0x90,0xc5,0x8a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x27,0x6d,0x20,0x4e,0x3c,0x69,0x03,0xdb,0xe0,0x49,0x1b,0xd8,0x08,0x4f,0xda,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x82,0xb5,0xe2,0xf7,0x47,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0xd8,0x89,0xdf,0x1f,0x01,0x00,0x00,0x00,0x00,0x1c,0xb2,0x21,0x2b,0x00,0x40,0xa1);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xc0,0x50,0x78,0x17,0xda,0xf4,0x80,0x51,0x1c,0x6f,0x42,0x9b,0x1e,0x30,0x8a,0xe3,0x3d);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xd0,0x68,0xd3,0x03,0x46,0x71,0xbc,0x05,0x6d,0x7a,0xc0,0x28,0x8e,0x77,0xa0,0x4d,0x0f);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xe0,0x18,0xc5,0xf1,0x06,0xb4,0xe9,0x01,0xa3,0x38,0x5e,0x80,0x36,0x3d,0x60,0x14,0xc7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xf0,0x2b,0xd0,0xa6,0x07,0x8c,0xe2,0x18,0x01,0xbf,0xdf,0x08,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x15);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xd9,0xe0,0xf7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0xa3,0x00,0x20,0x4b,0x07,0xab,0xc5,0x03,0x00,0x00,0xd6,0xc1,0x6a,0xf1,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x90);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0x75,0xa1,0x6a,0xb5,0x00,0x00,0x00,0x00,0x13,0x00,0xf0,0x00,0x14,0xd3,0x34,0xcd);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xc0,0x90,0x02,0x4d,0x10,0x20,0x10,0x06,0x6a,0xdb,0xb6,0x6d,0xdb,0xb6,0x35,0x4d,0xd3);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xd0,0x34,0x21,0x13,0x04,0x01,0x02,0x61,0xa8,0xb6,0x6d,0xdb,0xb6,0x6d,0xdb,0xb6,0x35);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xe0,0xcd,0xd0,0x02,0x4d,0x50,0x30,0x14,0x47,0x6a,0xdb,0xb6,0x6d,0xdb,0xb6,0x6d,0x5b);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xf0,0xd3,0x34,0x25,0x13,0x04,0x05,0x43,0x71,0xac,0xb6,0x6d,0xdb,0xb6,0x6d,0x5b,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x16);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x02,0x42,0x41,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x07,0x90,0x00,0x00,0x00,0x00,0xf0,0x20);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x18);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xef,0xbd,0xf7,0xde,0x7b,0xef,0xbd,0x07,0x08,0x08,0x0a,0x0c,0x0c,0x0c,0x0c,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x0c,0x0c,0x0c,0x5c,0x09,0xa8,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0x5a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x09,0x04,0xff,0x00,0x80);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x10,0xb0,0x80,0x00,0x04,0x20,0x00,0x01,0x08,0x40,0x00,0x02,0x10,0x80,0x00,0x04,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x19);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xc0,0xaf,0xa3,0x9b,0x92,0x8d,0x8a,0x86,0x84,0x83,0x82,0x81,0x00,0x50,0xf6,0xcf);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0xfc,0x2f,0xf3,0xef,0xcf,0xbf,0x0f,0xff,0xaf,0xb5,0x71,0x0e,0x6c,0x4a,0x69,0x08);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x05,0xa0,0x03,0x03,0x68,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x1a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x04,0x08,0x0c,0x00,0x10,0x14,0x18,0x1c,0x00,0x20,0x28,0x30,0x38,0x00,0x40);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xa0,0xa8);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0xb0,0xb8,0x00,0xc0,0xc8,0xd0,0xd8,0x00,0xe0,0xe8,0xf0,0xf8,0x00,0xfc,0xfe,0xff);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0x00,0x00,0x04,0x08,0x0c,0x00,0x10,0x14,0x18,0x1c,0x00,0x20,0x28,0x30,0x38,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xc0,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xa0);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xd0,0xa8,0xb0,0xb8,0x00,0xc0,0xc8,0xd0,0xd8,0x00,0xe0,0xe8,0xf0,0xf8,0x00,0xfc,0xfe);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xe0,0xff,0x00,0x00,0x04,0x08,0x0c,0x00,0x10,0x14,0x18,0x1c,0x00,0x20,0x28,0x30,0x38);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xf0,0x00,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x1b);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xa0,0xa8,0xb0,0xb8,0x00,0xc0,0xc8,0xd0,0xd8,0x00,0xe0,0xe8,0xf0,0xf8,0x00,0xfc);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x05,0x90,0xfe,0xff,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x20);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x08,0x80,0x81,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x22);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x0e,0x80,0x2d,0xd3,0x00,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x9f,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x23);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x01,0x05,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x0d,0x90,0xff,0x0f,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0xff,0x07,0x25);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x24);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x03,0x00,0xff,0xff,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xa6);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x5a,0x5a,0x5a,0x55,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x42,0x24);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x90,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x2f);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x19,0x00);
    //delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x02,0x5a);
    //delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x02,0x00);
*/

 delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x41,0x5a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x4c,0x03);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x24);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x90,0x5a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x03);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x80,0x19,0x01);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x08);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x04,0x80,0x19,0x2d,0x05);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x09);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x5a,0x51,0xb5,0x2a,0x6c,0xe5,0x4a,0x01,0x40,0x62,0x0f,0x82,0x20,0x08,0xf0,0xb7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x00,0x24,0x42,0x0a,0xe3,0x91,0xa4,0xf0,0xc2,0xb9,0x6b,0x20,0x19,0xa1,0x26,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0x51,0x55,0x55,0x00,0xa0,0x4d,0x06,0x11,0x0d,0x60,0x5a,0xff,0xff,0x03,0xa5,0xe6);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0x08,0xc9,0x16,0x64,0x0b,0x00,0x00,0x11,0x07,0x60,0x00,0xff,0xff,0x03,0xff,0x34);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x09,0xc0,0x0c,0x3f,0x1f,0x9f,0x0f,0x00,0x08,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xff,0xb6,0x6d,0x03,0x00,0x14,0x23,0x36,0x49,0x5c,0x63,0x98,0x83,0xbe,0x76,0x41);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x7b,0x50,0x4d,0x3e,0x2e,0x1f,0x10,0x0b,0x00,0x14,0x23,0x36,0x49,0x5c,0x63,0x98);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x0e,0xa0,0x83,0xbe,0x76,0x41,0x7b,0x50,0x4d,0x3e,0x2e,0x1f,0x10,0x0b,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0b);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x00,0x20,0x44,0x08,0x00,0x60,0x47,0x00,0x00,0x10,0x22,0x04,0x00,0xb0,0x23);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x90,0x15,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xfa,0x68,0x68,0x01,0xb2,0x75,0xb0,0x04,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x15,0x55,0x61,0x15,0x00,0x60,0x15,0x00,0x50,0x15,0x56,0x51,0x15,0x55,0x61,0x95);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0xab,0x18,0x00,0x05,0x00,0x05,0x00,0x05,0x80,0x4c,0x29,0x84,0x52,0x01,0x09,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0xb0,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0d);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x08,0x80,0xf0,0xb1,0x71,0xef,0x4b,0xc0,0x80);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0e);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x09,0x80,0xff,0x01,0x55,0x55,0x23,0x88,0x88,0x1c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x0f);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x14,0x40,0x6f,0xc0,0x12,0x08,0x64,0x08,0x52,0x31,0x58,0x49,0x03,0x52,0x4c,0x4c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x68,0x68,0x68,0x4c,0x4c,0x7c,0x14,0x00,0x20,0x06,0xc2,0x00,0x04,0x06,0x0c,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x05,0xa0,0x00,0x92,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x10);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x00,0x03,0xe7,0x1f,0x17,0x10,0x48,0x80,0xaa,0xd0,0x18,0x30,0x88,0x41,0x8a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x10,0x90,0x39,0x28,0xa9,0xc5,0x9a,0x7b,0xf0,0x07,0x7e,0xe0,0x07,0x7e,0x20,0x10,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x11);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x49,0x77,0x03,0x40,0xca,0xf3,0xff,0x83,0x30,0x08,0xc4,0x06,0xa1,0xd8,0x24,0x18);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x30,0xc6,0x66,0xc1,0x80,0x31,0x15,0xcb,0xe5,0xd2,0x68,0x6c,0x36,0x1d,0x04,0xc8);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0xb0,0xd9,0x88,0x60,0xb0,0x81,0x40,0x1a,0x1b,0x48,0x63,0x03,0xb9,0x00,0x1c,0x80);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0x50,0x30,0x00,0xe0,0xe1,0x01,0x00,0x28,0x0e,0x06,0x43,0x55,0x55,0x55,0x55,0x55);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xc0,0x95,0x88,0x88,0x88,0x88,0x88,0xc8,0x08,0x86,0xc6,0xe3,0x81,0x00,0x20,0x00,0x21);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xd0,0x42,0x88,0x00,0x00,0x00,0x00,0x40,0x00,0x00,0x31,0x04,0x41,0x06,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xe0,0x00,0x92,0x04,0x00,0x92,0x04,0x00,0x00,0x00,0x00,0x92,0x04,0x00,0x85,0x11,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x10,0xf0,0x00,0x00,0x40,0x00,0x00,0x00,0x00,0x5e,0x4a,0x01,0x78,0x00,0x08,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x12);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x00,0x00,0x00,0x00,0x02,0x03,0x00,0x00,0x00,0x00,0x02,0x03,0x00,0x41,0x37);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0xf1,0xe7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2d,0x23,0x05);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x08,0xa0,0xfb,0x08,0x2d,0x23,0x05,0xfb,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x13);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xfd,0x0f,0x00,0x0c,0x00,0x00,0x00,0x00,0x01,0x08,0x01,0x1c,0x44,0x0c,0xce,0xe7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x0f,0x90,0x62,0x0e,0x24,0x98,0xac,0x21,0x01,0x00,0xd0,0xff,0xff,0xff,0x07,0x20);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x14);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x01,0x02,0x41,0x36,0xe1,0xef,0xf7,0xfb,0xfd,0x7e,0x01,0x00,0x00,0x90,0xc5,0x8a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x27,0x6d,0x20,0x4e,0x3c,0x69,0x03,0xdb,0xe0,0x49,0x1b,0xd8,0x08,0x4f,0xda,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf8,0x82,0xb5,0xe2,0xf7,0x47,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0xd8,0x89,0xdf,0x1f,0x01,0x00,0x00,0x00,0x00,0x1c,0xb2,0x21,0x2b,0x00,0x40,0xa1);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xc0,0x50,0x78,0x17,0xda,0xf4,0x80,0x51,0x1c,0x6f,0x42,0x9b,0x1e,0x30,0x8a,0xe3,0x3d);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xd0,0x68,0xd3,0x03,0x46,0x71,0xbc,0x05,0x6d,0x7a,0xc0,0x28,0x8e,0x77,0xa0,0x4d,0x0f);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xe0,0x18,0xc5,0xf1,0x06,0xb4,0xe9,0x01,0xa3,0x38,0x5e,0x80,0x36,0x3d,0x60,0x14,0xc7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xf0,0x2b,0xd0,0xa6,0x07,0x8c,0xe2,0x18,0x01,0xbf,0xdf,0x08,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x15);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xd9,0xe0,0xf7);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0xa3,0x00,0x20,0x4b,0x07,0xab,0xc5,0x03,0x00,0x00,0xd6,0xc1,0x6a,0xf1,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x90);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0x75,0xa1,0x6a,0xb5,0x00,0x00,0x00,0x00,0x13,0x00,0xf0,0x00,0x14,0xd3,0x34,0xcd);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xc0,0x90,0x02,0x4d,0x10,0x20,0x10,0x06,0x6a,0xdb,0xb6,0x6d,0xdb,0xb6,0x35,0x4d,0xd3);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xd0,0x34,0x21,0x13,0x04,0x01,0x02,0x61,0xa8,0xb6,0x6d,0xdb,0xb6,0x6d,0xdb,0xb6,0x35);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xe0,0xcd,0xd0,0x02,0x4d,0x50,0x30,0x14,0x47,0x6a,0xdb,0xb6,0x6d,0xdb,0xb6,0x6d,0x5b);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xf0,0xd3,0x34,0x25,0x13,0x04,0x05,0x43,0x71,0xac,0xb6,0x6d,0xdb,0xb6,0x6d,0x5b,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x16);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x02,0x42,0x41,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x07,0x90,0x00,0x00,0x00,0x00,0xf0,0x20);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x18);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xef,0xbd,0xf7,0xde,0x7b,0xef,0xbd,0x07,0x08,0x08,0x0a,0x0c,0x0c,0x0c,0x0c,0x0c);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x0c,0x0c,0x0c,0x5c,0x09,0xa8,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0x5a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x59,0x09,0x04,0xff,0x00,0x80);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x10,0xb0,0x80,0x00,0x04,0x20,0x00,0x01,0x08,0x40,0x00,0x02,0x10,0x80,0x00,0x04,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x19);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xc0,0xaf,0xa3,0x9b,0x92,0x8d,0x8a,0x86,0x84,0x83,0x82,0x81,0x00,0x50,0xf6,0xcf);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0xfc,0x2f,0xf3,0xef,0xcf,0xbf,0x0f,0xff,0xaf,0xb5,0x71,0x0e,0x6c,0x4a,0x69,0x08);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x05,0xa0,0x03,0x03,0x68,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x1a);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x04,0x08,0x0c,0x00,0x10,0x14,0x18,0x1c,0x00,0x20,0x28,0x30,0x38,0x00,0x40);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xa0,0xa8);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xa0,0xb0,0xb8,0x00,0xc0,0xc8,0xd0,0xd8,0x00,0xe0,0xe8,0xf0,0xf8,0x00,0xfc,0xfe,0xff);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xb0,0x00,0x00,0x04,0x08,0x0c,0x00,0x10,0x14,0x18,0x1c,0x00,0x20,0x28,0x30,0x38,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xc0,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00,0xa0);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xd0,0xa8,0xb0,0xb8,0x00,0xc0,0xc8,0xd0,0xd8,0x00,0xe0,0xe8,0xf0,0xf8,0x00,0xfc,0xfe);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xe0,0xff,0x00,0x00,0x04,0x08,0x0c,0x00,0x10,0x14,0x18,0x1c,0x00,0x20,0x28,0x30,0x38);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0xf0,0x00,0x40,0x48,0x50,0x58,0x00,0x60,0x68,0x70,0x78,0x00,0x80,0x88,0x90,0x98,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x1b);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0xa0,0xa8,0xb0,0xb8,0x00,0xc0,0xc8,0xd0,0xd8,0x00,0xe0,0xe8,0xf0,0xf8,0x00,0xfc);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x05,0x90,0xfe,0xff,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x20);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x08,0x80,0x81,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x22);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x0e,0x80,0x2d,0xd3,0x00,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x9f,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x23);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x01,0x05,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x0d,0x90,0xff,0x0f,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0xff,0x07,0x25);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x24);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x80,0x00,0x03,0x00,0xff,0xff,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x52,0xa6);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x11,0x90,0x5a,0x5a,0x5a,0x55,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x42,0x24);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x90,0x00);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x29,0x00,0x03,0x41,0x5a,0x2f);
    delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x15,0x00,0x02,0x19,0x00);






	//----------------------LCD initial code End----------------------//
	
	// BIST MODE
//	delayUs(100);hal_dsi_tx_ctrl_write_cmd(0x39,0,2,0x02,0x5A);
	//SPI FINISH
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x42, 0x24);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x90, 0x00);
	//Blank select 2F 
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x41, 0x5A, 0x2F);
	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x19, 0x00);

	// Video Mode Enable
//	delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x39,0x00,0x03,0xB7,0x59,0x02);

	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x11);
	delayMs(5);
	hal_gpio_set_output_data(IO_PAD_PWMEN, IO_LVL_HIGH);
	delayMs(5);
//	hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_HIGH);
	hal_gpio_set_output_data(IO_PAD_AP_SWIRE, IO_LVL_HIGH);
	
//	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 3, 0x51, 0xff, 0x0f);
//	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x53, 0x24);
//	hal_dsi_tx_ctrl_write_cmd(0x39, 0, 2, 0x55, 0x00);



#endif
#endif

#endif

#if 0
		uint8_t data[10] = {0};
		hal_dsi_tx_ctrl_read_cmd(0x06, 0, 0x0A, 1, data);
		TAU_LOGI("read[0x%02x]:%02x\n", 0x0A, data[0]);
#endif


    /* exit send initial code mode*/
    hal_dsi_tx_ctrl_exit_init_panel_mode();
    delayMs(10);
}

static void open_mipi_rx(void)
{
    /* TE */
    hal_gpio_set_mode(IO_PAD_AP_TE, IO_MODE_TEAR);

    if (g_rx_ctrl_handle == NULL)
    {
        /* rx   ctrl handle */
        g_rx_ctrl_handle = hal_dsi_rx_ctrl_create_handle();
    }
    /* ò */
    g_rx_ctrl_handle->base_info.src_w = INPUT_WIDTH;
    g_rx_ctrl_handle->base_info.src_h = INPUT_HEIGHT;
    g_rx_ctrl_handle->base_info.dst_w = OUTPUT_WIDTH;
    g_rx_ctrl_handle->base_info.dst_h = OUTPUT_HEIGHT;
    g_rx_ctrl_handle->base_info.src_frate = INPUT_FRAME_RATE;
    g_rx_ctrl_handle->base_info.src_mode = INPUT_DATA_MODE;
    g_rx_ctrl_handle->rx_color_mode = INPUT_COLOR_MODE;
    g_rx_ctrl_handle->rx_lanes = INPUT_MIPI_LANE_NUM;
    g_rx_ctrl_handle->rx_nonburst_models = INPUT_VIDEO_MODEL; /* ɲ */
    g_rx_ctrl_handle->rx_vc = INPUT_VC;
    g_rx_ctrl_handle->compress_en = INPUT_COMPRESS;
    g_rx_ctrl_handle->rx_hsclk_rate = INPUT_MIPI_LANE_RATE;
    g_rx_ctrl_handle->cus_dcs_entry_table = g_cus_rx_dcs_execute_table; /* ע DCSб */
    g_rx_ctrl_handle->rx_dcs_read_entry = ap_dcs_read; /* עdsc read ص,ѡ,˺Ϊʱcus_dcs_entry_tableִ */
    g_rx_ctrl_handle->pps_update_entry = pps_update_handle;
    g_rx_ctrl_handle->pq_marginal = true;  //true:ˮơfalse
    /* ǰԤPPS,  AP PPS cmdҲ */

    /* ʼrx ctrl */
    hal_dsi_rx_ctrl_init(g_rx_ctrl_handle);		
	hal_dsi_rx_ctrl_set_cus_sync_line(g_rx_ctrl_handle, 2400);// lss add, ˺1600
 //   hal_dsi_rx_ctrl_hight_performan_mode(g_rx_ctrl_handle);
	hal_dsi_rx_ctrl_set_cus_scld_filter(g_rx_ctrl_handle,rx_filter_1080_h_4_70,rx_filter_2240_v_4_70);
    /* rx ctrl */
    hal_dsi_rx_ctrl_start(g_rx_ctrl_handle);
	//hal_dsi_rx_ctrl_set_auto_hw_filter(g_rx_ctrl_handle, true);

//	delayMs(20);
}

static void init_mipi_tx(void)
{
    if (g_tx_ctrl_handle == NULL)
    {
        g_tx_ctrl_handle = hal_dsi_tx_ctrl_create_handle();
    }
    g_tx_ctrl_handle->channel_id = OUTPUT_VC;
    g_tx_ctrl_handle->lane_num = OUTPUT_LANE_NUMBER;
    g_tx_ctrl_handle->vid_mode = OUTPUT_VIDEO_MODEL;
    g_tx_ctrl_handle->cmd_tx_type = _CMD_TYPE;
    g_tx_ctrl_handle->dpi_vsa = OUTPUT_VSA;
    g_tx_ctrl_handle->dpi_vbp = OUTPUT_VBP;
    g_tx_ctrl_handle->dpi_vfp = OUTPUT_VFP;
    g_tx_ctrl_handle->dpi_hsa = OUTPUT_HSA;
    g_tx_ctrl_handle->dpi_hbp = OUTPUT_HBP;
    g_tx_ctrl_handle->dpi_hfp = OUTPUT_HFP;
//    g_tx_ctrl_handle->lane_rate_coef = _LANE_RATE_COEF;
    g_tx_ctrl_handle->base_info.src_w = INPUT_WIDTH;
    g_tx_ctrl_handle->base_info.src_h = INPUT_HEIGHT;
    g_tx_ctrl_handle->base_info.dst_w = OUTPUT_WIDTH;
    g_tx_ctrl_handle->base_info.dst_h = OUTPUT_HEIGHT;
    g_tx_ctrl_handle->base_info.src_frate = INPUT_FRAME_RATE;
    g_tx_ctrl_handle->base_info.src_mode = INPUT_DATA_MODE;
		
		g_tx_ctrl_handle->tx_frame_rate = 60;	
		g_tx_ctrl_handle->tx_clkawayshs = true;	
//	g_tx_ctrl_handle->tx_line_delay = 600;
	
    hal_dsi_tx_ctrl_init(g_tx_ctrl_handle);
    /* AP ûзʱĬϵʾɫ, Ϊ0 0 0(ɫ), ɫΪdebugʹ */
    hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0x00);
    
     //#define INPUT_WIDTH  1080
     //#define INPUT_HEIGHT 2244 
     
     
//    #define OUTPUT_WIDTH 720
//    #define OUTPUT_HEIGHT 1600
  
    /*ȱֱͼ*/
    //ԭװ18.79װ209
    //Ҽ25(18.7:9),20(18.9:9),15(19.2:9) 
    
    //20230419ͻƫ
    // ٳ1618ͼ첻أպߺڱߡ
    // ڳ1518ͼе㣬λúԭװӽ
    hal_dsi_tx_crop_t *crop;
    crop->crop_top=0;
    crop->crop_bottom=0; 
    crop->crop_left=15;  
    crop->crop_right=15; 
    hal_dsi_tx_crop_pic(g_tx_ctrl_handle,crop);
    
#if CUS_SCLD_FILTER
 //   hal_dsi_tx_ctrl_set_cus_pq_filter(g_tx_ctrl_handle, tx_filter_H, tx_filter_V);
#endif	
}

static void AP_SWIRE_init()
{
	uint8_t i;
	
    hal_gpio_set_output_data(IO_PAD_ADCIN, IO_LVL_HIGH);
    delayMs(1);

    for(i=0; i<5; i++)
    {
    	hal_gpio_set_output_data(IO_PAD_ADCIN,IO_LVL_LOW);
    	delayUs(10);
    	hal_gpio_set_output_data(IO_PAD_ADCIN,IO_LVL_HIGH);
    	delayUs(10);
    }
}


static void tx_display_on(void)
{
    init_panel();
//	delayMs(150);
    hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
	delayMs(150);
	delayUs(50);hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);
	
//	delayMs(40);
//	hal_gpio_set_output_data(IO_PAD_AP_SWIRE, IO_LVL_HIGH);
//	delayMs(200);
//	delayMs(50);
//	hal_dsi_tx_ctrl_write_cmd(0x05, 0, 1, 0x29);
	TAU_LOGD("write 29\n");
	
/*	if(g_resolution_change)
	{
        hal_dsi_rx_ctrl_toggle_resolution(g_rx_ctrl_handle);
        //hal_dsi_rx_ctrl_set_auto_hw_filter(g_rx_ctrl_handle, true);
        TAU_LOGD("resolutio toggle\n");
	}
*/
    panel_display_done = true;

}

static void swire_timer_callback(void *data)
{
   hal_swire_start(12, 12, 12, 12, swire_num);
}

static void swire_callback(void *data)
{
    /* swire ǷҪһֱҪֻֻͬͬ */
    //if(start_display_on == false)
    {
        hal_timer_start(SWIRE_TIMER, 26, swire_timer_callback, NULL);
    }
}

/* swire ʼ,ͨ hal_swire_start , ѭһֱ */
static void swire_init()
{
    hal_swire_open(DISABLE);
    hal_swire_init();
    /* swire ηɺص */
    hal_swire_register_callback(swire_callback);
    hal_swire_open(ENABLE);
    //hal_swire_start(12, 12, 12, 12, 43);
    hal_swire_start(12, 12, 12, 12, 36); //3~27,~,9.45V~7.43V
    hal_timer_init(SWIRE_TIMER);
    hal_timer_start(SWIRE_TIMER, 26, swire_timer_callback, NULL);
}



#if 0 // TEST RGB, From Lin
void RGB_TEST(void)
{
	tx_display_on();
	while (1)
	{
		
		hal_dsi_tx_ctrl_set_overwrite_rgb(0xFF, 0x00, 0x00); // RED
		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		delayMs(1000);

		
		hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0xFF, 0x00); // GREEN
		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		delayMs(1000);

		
		hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0xFF); // BLUE
		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		delayMs(1000);

		
		hal_dsi_tx_ctrl_set_overwrite_rgb(0xFF, 0xFF, 0xFF); // WHITE
		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		delayMs(1000);

		
		hal_dsi_tx_ctrl_set_overwrite_rgb(0x00, 0x00, 0x00); // BLACK
		hal_dsi_tx_ctrl_start(g_tx_ctrl_handle);
		delayMs(1000);

	}

}
#endif



void ap_demo(void)
{
	hal_gpio_init_output(IO_PAD_PWMEN, IO_LVL_LOW);
	hal_gpio_init_output(IO_PAD_ADCIN, IO_LVL_LOW);
	hal_gpio_init_output(IO_PAD_AP_SWIRE, IO_LVL_LOW);
	hal_pwm_out_sel_io(IO_PAD_AP_SWIRE);
	/* mipi rxʼ */
	open_mipi_rx();
	
    PWM_init(); 
	AP_SWIRE_init();
	#if SHARE_FLASH_MODE
		hal_system_share_flash_mode(true); // ʹڲFLASH
	#endif
    
	/* swire ʼ */
//	swire_init();
	
	/* Ӧ,1.8V  AP TP1.8, PWMEN ӵ AP AVDD_SWIRE, ڼϢAC */

	if (hal_gpio_get_input_data(IO_PAD_AP_TPRSTN))
	{
	/* Ϣ */
	start_display_on = true;
	TAU_LOGD("DC\n");
	}
	else
	{
	/* AC */
	TAU_LOGD("AC\n");
	}
	
//	NVIC_SetPriority(I2C0_IRQn, 0x00);
//	NVIC_SetPriority(I2C1_IRQn, 0x01);	
	/* TP1.8е֮ǰʹTEʾ֮лΪӲTE */
//	soft_te_timer_init();
		
	/* mipi tx ʼ*/
    
	init_mipi_tx();
		
	#if 0 // TEST RGB, From Lin
		RGB_TEST();
	#endif

	/* touch ģʼ */
	app_tp_init();

//	    hal_dsi_rx_ctrl_enable_test_pattern(g_rx_ctrl_handle, 0, true);//TEST
	loop_count =1;
	while (1)
	{		
		/* ȴ AP TP ϵ*/
		if (start_display_on == true)
		{
			/* ʼ */
			tx_display_on();
			
			#if SHARE_FLASH_MODE
				//hal_system_share_flash_mode(false); // ڲFLASHر
			#endif
			
			start_display_on = false;
			panel_display_done = true;
			
			app_tp_phone_clear_reset_on();
			
			/* TP ģͨѶʼ */
			#ifndef DISABLE_TDDI_I2C_FUNCTION
				app_tp_transfer_screen_start();
			#endif
		}
		
		if(panel_display_done)
		{
				PWM_Task();
		}
		/* ȴ TP жϱTP Эת */
		#ifndef DISABLE_TDDI_I2C_FUNCTION
			app_tp_transfer_screen_int();
		#endif
		
		while (hal_dsi_rx_ctrl_dsc_async_handler(g_rx_ctrl_handle));
	
	}
}

